loopmax = 65
normal macro
local n1
; this macro normalizes dx:ax after a multiply
; we will use 4000h for 1
       add   ax,03ffh   ; what does this do?
       jnc   n1
       inc   dx
n1:
       mov   al,ah      ; shift 8 bits to right
       mov   ah,dl
       mov   dl,dh
       shr   dl,1
       rcr   ax,1
       shr   dl,1
       rcr   ax,1
       clc
      endm
cseg      segment para public 'CODE'
          assume   cs:cseg,ds:cseg,ss:cseg,es:cseg
          org   100h
start: jmp  main
;
eighty dw  80
pmax   dw  0240h
pmin   dw  0120h
qmax   dw  0280h
qmin   dw  0140h
xloc   dw  0
yloc   dw  0
delx   dw  0
dely   dw  0
xlast  dw  0
ylast  dw  0
main      proc     near
; throw us into graphics mode
          mov    ah,0
          mov    al,13h
          int    10h
; calc dx and dy
       mov  dx,0
       mov  ax,pmax
       sub  ax,pmin
;      shl  ax,1
;      rcl  dx,1
       shl  ax,1
       rcl  dx,1
       shl  ax,1
       rcl  dx,1
       shl  ax,1
       rcl  dx,1
       shl  ax,1
       rcl  dx,1
       mov  cx,320
       div  cx
       mov  delx,ax
       mov  dx,0
       mov  cx,200
       mov  ax,qmax
       sub  ax,qmin
;      shl  ax,1
;      rcl  dx,1
       shl  ax,1
       rcl  dx,1
       shl  ax,1
       rcl  dx,1
       shl  ax,1
       rcl  dx,1
       shl  ax,1
       rcl  dx,1
       div  cx
       mov  dely,ax
;
       mov  cx,320
       mov  xloc,0
xloop:
; this is the loop to go through the columns
       push  cx
       mov   yloc,0
       mov   cx,200
yloop:
; loop through the rows
       push  cx
;
       call  setpq   ; sets up the si and di registers for p and q
       mov   cx,loopmax
mloop:
       push  cx
; this is the mandelbrot loop
       call  mandel
        pop cx
       jc    donem
        loop mloop
donem:
        call  do_dot
done_loop:
       call  test_key
; bump the y
       inc   yloc
       pop   cx
       loop  yloop
       inc   xloc
       pop   cx
       loop  xloop
;
wait_more:
          mov    ah,0
          int    16h
          cmp    al,27
          jne    wait_more
wait_more2:
          mov    ah,0
          mov    ah,0
          mov    al,2
          int    10h
          int  20h
mandel:
; routine to do the mandle calcs
; calculate the x
       mov  ax,xlast
       imul  xlast
       normal
       mov  bx,ax
       mov  ax,ylast
       imul  ylast
       normal
       sub  bx,ax
       add  bx,si    ; what is si?
; calc the y
       mov  ax,xlast
       imul  ylast
       normal
       shl  ax,1
       add  ax,di
; save the x and y
       mov  xlast,bx
       mov  ylast,ax
; now  calc the modulus
       mov  ax,ylast
       imul  ylast
       normal
       mov  bx,ax
       mov  ax,xlast
       imul  xlast
       normal
       add  ax,bx
       jc   donem1
       clc
       ret
donem1:
       stc
       ret
do_dot:
       ; converts xloc and yloc to a position and plots it
; al has the color to do
; cx has the column, bx has the row
   push  es
   push  dx
   push  cx
   push  bx
   mov   ax,loopmax
   sub   ax,cx
   push  ax
   mov   bx,xloc
   mov   ax,yloc; y location
   mov   cx,320
   imul  cx
   add   bx,ax
   mov  ax,0a000h
   mov  es,ax
   pop   ax
   mov   es:[bx],al
   pop   bx
   pop   cx
   pop   dx
   pop   es
   ret
setpq:
; set up registers
       mov  si,pmin ; si will have the current p
       mov  ax,xloc
       imul  delx
;      shr   dx,1
;      rcr   ax,1
       shr   dx,1
       rcr   ax,1
       shr   dx,1
       rcr   ax,1
       shr   dx,1
       rcr   ax,1
       shr   dx,1
       rcr   ax,1
       add  si,ax
       mov  di,qmin ; di will have the current q
       mov  ax,yloc
       imul  dely
;      shr   dx,1
;      rcr   ax,1
       shr   dx,1
       rcr   ax,1
       shr   dx,1
       rcr   ax,1
       shr   dx,1
       rcr   ax,1
       shr   dx,1
       rcr   ax,1
       add  di,ax
       mov   xlast,0
       mov   ylast,0
       mov   bp,0   ; bp is the color
       ret
test_key:
; test for a keystroke
       mov  ax,0100h
       int  16h
       jz   no_key
       mov  ah,0
       int  16h
       cmp  al,27
       jne  no_key
       jmp  wait_more2
no_key:
       ret
main      endp
cseg      ends
          end      start
