print macro string
         lea dx,string
         mov    ah,9
         int    21h
         endm
segmentsize EQU  8000h
dseg     SEGMENT PUBLIC 'DATA'
         ASSUME CS:cseg,DS:dseg,SS:sseg,ES:dseg
buffer  dw 0
public buffer
psp      dw  0
start_stack dw  0
ret_sp   dw  0
sav_brk  dw  0
breaker  dw  0
lpt      dw  0
        db 13,10,'OKBRAND.COM OPTIKS Serializer',13,10
        db 'Copyright 1989 by Keith P. Graham',13,10,26
err1    db 13,10,'Memory allocation error',13,10,'$'
thanks  db 13,10,'Thanks for using OKBRAND.EXE',13,10,'$'
;
dseg     ENDS
;
;
cseg     SEGMENT PARA PUBLIC 'CODE'
PUBLIC   reset_segs,end_prog,exit_prog
         ASSUME CS:cseg,DS:dseg,SS:sseg,ES:dseg
extrn  brand:near
entry    PROC   far
; entry procedure
; shrink
; must shrink down to stack segment which is always last
         MOV     BX,sseg
         mov     ax,es
         sub     bx,ax
         add     BX,64   ;64*16 = 1024 bytes
         MOV     AH,4ah
         INT     21h
         jnc     ok_stack
         lea     dx,err1
         jmp     end_prog
ok_stack:
; set stack
         CLI
         MOV     SP,1020
         STI
; set up return
         XOR     AX,AX
         PUSH   DS
         PUSH   AX
         MOV     AX,dseg
         MOV     DS,AX
         MOV     psp,ES
         MOV     start_stack,SS
         MOV     ret_sp,SP
         MOV     AX,dseg
         MOV     ES,AX
;
; allocate memory areas
;
         Jmp    goodget2
memory_error:
         lea     dx,err1
         JMP     end_prog
goodget2:
; allocate the IO buffers - 32k of them (16k for each)
         MOV     AH,48h
         MOV     BX,1000h;1000h*16 = 64k
         INT     21h
         jc     memory_error
         CMP     BX,1000h
         JNE     memory_error
         MOV     buffer,AX
; get configuration file
         call   reset_segs
;

; set up BREAK key exit
         CALL   break_on
         call   reset_segs
         call   brand
exit_prog:
        lea dx,thanks
; this is the normal menu exit
end_prog:
; in order to end the program there must be a message in dx
         PUSH   DX      ; this has the ending message
         CALL   reset_segs
         CALL   break_off
         POP     DX
         mov     ah,9
         int     21h
         MOV     SP,ret_sp
         mov    ah,4ch
         mov    al,0
         int    21h
         RET
entry    ENDP
reset_segs      PROC    NEAR
         PUSH   AX
         MOV     AX,dseg
         MOV     DS,AX
         MOV     ES,AX
         POP     AX
         RET
reset_segs      ENDP
eoi      EQU     20h     ;END OF INTERRUPT
brkint   EQU     1bh     ;BREAK INTERRUPT
break_on        PROC    NEAR
; this sets the control break, also sets critical error
;
; crit_err first
;
         LEA     DX,CS:break_it
         PUSH   DS
         MOV     AX,CS
         MOV     DS,AX
         MOV     AX,2524h
         INT     21h
         POP     DS
;
         PUSH   ES
         MOV     AX,351bh
         INT     21h
; es:bx returns with the interrupt
         MOV     sav_brk,BX     ;SAVE OFFSET
         MOV     sav_brk+2,ES    ;SAVE SEGMENT
         POP     ES
         LEA     DX,CS:break_it
         PUSH   DS
         MOV     AX,CS
         MOV     DS,AX
         MOV     AX,251bh
         INT     21h
         POP     DS
         RET
break_on        ENDP
break_off        PROC   NEAR
         MOV     DX,sav_brk     ;RESET VECTOR BACK TO OLD RTN
         MOV     AX,sav_brk+2
         PUSH   DS
         MOV     DS,AX
         MOV     AX,251bh
         INT     21h
         POP     DS
         RET
break_off        ENDP
break_it        PROC    NEAR
; break handler
         MOV     AL,eoi
         OUT     020h,AL
         CALL   reset_segs
         MOV     AX,sseg
         MOV     SS,AX
         MOV     SP,breaker
         STI
        lea dx,thanks
         jmp     end_prog
break_it        ENDP
cseg     ENDS
;
sseg     SEGMENT stack 'STACK'
         DW     64      DUP(0)
sseg     ENDS
         END     entry
