public f8,wsaveh
dowindow macro x
          lea  di,wsaveh
          lea  si,window0
        call getwind
         endm
unwind    macro  x
          lea  si,wsaveh
          call retwind
          endm
cseg segment byte public 'CODE'
assume  cs:cseg,ds:cseg,es:cseg
;
rowsh    equ 18
colsh    equ 43
windxh   equ 00
windyh   equ 00
colorh   equ 2fh
hidexh   equ windxh+(colsh/2)+1
hideyh   equ windyh+rowsh
rows     db rowsh
cols     db colsh
windx    db windxh
windy    db windyh
color1    db colorh
color2    db colorh
hidex    db hidexh
hidey    db hideyh
hpage     db  0
mpage     db  18
ftable db  1,2,3,4,6,7,11,12,14,17
wtable dw   window0
       dw   help1
       dw   help2
       dw   help3
       dw   help4
       dw   help5
       dw   help6
       dw   help7
       dw   help7a
       dw   help7b
       dw   help7c
       dw   help8
       dw   help9
       dw   help9a
       dw   help10
       dw   help10a
       dw   help11
       dw   help14
       dw   help15
cursor   dw  0
cursmode dw  0
bhpage   db  0
cpage     db  0
dpage     db  0
jtable   dw  escape,home,pgup,pgdn,endkey
;
;window 8
helps   db  1
wsaveh  dw 800 dup(0)
f8      proc   near
; first get the cursor location
        call getcurs
        dowindow  0
        mov  dpage,100
getchar:
        mov  al,dpage
        cmp  cpage,al
        je   func0
page0:
        call newpage
func0:
        call getop
        cmp  bx,0
        je   func0
        cmp  bx,10
        jg   g10
        dec  bx
        mov  al,ftable[bx]
        mov  cpage,al
        jmp  getchar
g10:
         sub bx,11
         add bx,bx
         jmp jtable[bx]
escape:
        jmp  exit_prog
pgup:
        cmp  cpage,0
        je   jmpback
        sub  cpage,1
jmpback:
        jmp  getchar
pgdn:
        mov  al,mpage
        cmp  cpage,al
        jge  jmpback
        add  cpage,1
        jmp  getchar
endkey :
       mov  al,mpage
        mov  cpage,al
        jmp  getchar
home:
        mov  al,hpage
        mov  cpage,al
        jmp   getchar
exit_prog:
        unwind   0
        call retcurs
       ret
f8     endp
newpage   proc  near
; cpage has the current page to display
; dpage will have the displayed page
;
; first clear the window
; set upper left
          mov ch,windy
          add ch,1
          mov cl,windx
          add cl,1
; set lower right
          mov dh,windy
          add dh,rows
          sub dh,2
          mov dl,windx
          add dl,cols
          sub dl,2
          mov bh,color1
          mov ah,7
          mov al,0
          int 10h
; position the cursor
; now set up the windowing
          mov  bl,cpage
          add bl,cpage
          mov  bh,0
           mov  si,wtable[bx]
;  si has the offest of the print area
          mov dh,windy
          inc  dh
          mov dl,windx
          inc  dl
; dx has the current cursor location
;   position cursor at present dx
nextchar1:
          mov  ah,2
          mov bh,bhpage
          int  10h
nonextchar:
          lodsb
          cmp  al,0
          je   endpage
          cmp  al,10
          je  nonextchar
          cmp  al,13
          jne  checkloc
          mov dl,windx
          add dl,1
          add dh,1
          jmp  nextchar1
checkloc:
          mov  bl,windx
          add  bl,cols
          sub  bl,1
          cmp  dl,bl
          jl   check_col
          jmp  nonextchar
check_col:
          mov  bl,windy
          add  bl,rows
          sub  bl,1
          cmp  dh,bl
          jl   docharacter
          jmp  endpage
docharacter:
          push dx
          mov  cx,1
          mov  ah,9
          mov  bh,bhpage
          mov  bl,color1
          int  10h
          pop  dx
          add  dl,1
          jmp  nextchar1
endpage:
          call hidecurs
          mov  al,cpage
          mov  dpage,al
          ret
newpage   endp
getwindx  proc near
getwind:
; locate at the line 1 position 10
          mov  cl,rows
          mov  ch,0
          mov  dh,windy
          sub  dh,1
gwloop:
          push cx
          add  dh,1
          mov  dl,windx
          sub  dl,1
          mov  cl,cols
          mov  ch,0
gwloop2:
          jmp  gwloopbp
gwloop2e:
          pop  cx
          loop  gwloop2
          pop  cx
          loop gwloop
          jmp  hidecurs
gwloopbp:
          push  cx
          inc  dl
          push  dx
          mov  ah,2
          mov  bh,bhpage
          int  10h
; get word at cursor
          mov  ah,8
          mov  bx,0
          int  10h
          stosw
; put word at cursor
; here we set up the characters for the screen
; dh have the row, dl has the columns
          cmp  dh,windy ; are we on the top row?
          jne  nottop
          cmp  dl,windx
          jne  nottopleft
          mov  al,201
          jmp  gotsp
nottopleft:
          mov  al,windx
          add  al,cols
          sub  al,1
          cmp  dl,al
          jne  nottopr
          mov  al,187 ; top right
          jmp  gotsp
nottopr:
          mov  al,205 ; top line
          jmp  gotsp
nottop:
      ; check for bottom
          mov  al,windy
          add  al,rows
          sub  al,1
          cmp  al,dh
          jne  notbot
          cmp  dl,windx
          jne  notbotleft
          mov  al,200
          jmp  gotsp
notbotleft:
          mov  al,windx
          add  al,cols
          sub  al,1
          cmp  al,dl
          jne  notbotright
          mov  al,188
          jmp  gotsp
notbotright:
          mov  al,205
          jmp  gotsp
notbot:
          cmp  dl,windx
          jne  notleft
          mov  al,186
          jmp  gotsp
notleft:
          mov  al,windx
          add  al,cols
          sub  al,1
          cmp  dl,al
          jne  notright
          mov  al,186
          jmp  gotsp
notright:
          pop  dx
          jmp  gwloop2e
gotsp:
          pop  dx
          push ax
          mov  ah,2
          mov  bh,bhpage
          int  10h
          pop  ax
          mov  cx,1
          mov  ah,9
          mov  bh,bhpage
          mov  bl,color2
          int  10h
          jmp  gwloop2e
; then  hide the cursor
hidecurs:
;hidex0    equ windx0+(cols0/2)
;hidey0    equ windy0+rows0
          mov  al,cols
          dec  al
          shr  al,1
          add  al,windx
          mov  hidex,al
          mov  al,rows
          add  al,windy
          sub  al,1
          mov  hidey,al
          mov  dl,hidex
          mov  dh,hidey
          mov  ah,2
          mov   bh,bhpage
          int   10h
          mov  al,219
          mov  cx,1
          mov  ah,9
          mov  bh,bhpage
          mov  bl,color2
          int  10h
          ret
getwindx  endp
retwindx  proc  near
retwind:
; locate at the line 1 position 10
          mov  cl,rows
          mov  ch,0
          mov  dh,windy
          sub  dh,1
rwloop:
          push cx
          add  dh,1
          mov  dl,windx
          sub  dl,1
          mov  cl,cols
          mov  ch,0
rwloop2:
          push cx
          inc  dl
          mov  ah,2
          mov  bh,bhpage
          int  10h
; put word at cursor
          lodsw
      ;   ah has the  attribute, al, has the character
          mov  cx,1
          mov  bl,ah
          mov  ah,9
          mov  bh,bhpage
          int  10h
          pop  cx
          loop  rwloop2
          pop  cx
          loop rwloop
          ret
retwindx  endp
getcursx  proc  near
getcurs:
; get video state
          mov ah,15
          int 10h
          mov bhpage,bh
          mov ah,3
          mov bh,bhpage
          int  10h
          mov  cursor,dx
          mov  cursmode,cx
          ret
getcursx  endp
retcursx  proc  near
retcurs:
          mov ah,2
          mov  dx,cursor
          mov bh,bhpage
          int  10h
          ret
retcursx  endp
getopx    proc  near
getop:
; get the option
; us bios interrupts as DOS screws you on get character
         mov  ah,0
         int   16h
; al gets character, ah has scan code
;        now decode
         cmp  al,27
         jne  no27
         mov  bx,11
         ret
no27:
        cmp  ah,47h  ; home
        jne  nohome
        mov   bx,12
        ret
nohome:
        cmp  ah,49h  ; pgup
        jne  nopgup
        mov   bx,13
        ret
nopgup:
        cmp  ah,51h  ; pgdn
        jne  nopgdn
        mov  bx,14
        ret
nopgdn:
        cmp  ah,4fh
        jne  noend
        mov  bx,15
        ret
noend:
        cmp  ah,3bh
        jl nocharx
        cmp  ah,44h
        jg  nocharx
        jmp gotafunc
nocharx:
        mov  bx,0
        ret
gotafunc:
        sub ah,3ah
        mov bl,ah
        mov bh,0
        ret
getopx    endp
window0  db  '                Help Index',13
         db  ' Esc = Exit help',13
         db  ' F1  = Installing the HP LaserJet',13
         db  ' F2  = CLASER Start up options',13
         db  ' F3  = Calling up CLASER',13
sd       db  ' F4  = Primary and Alternate Fonts',13
         db  '   and Selecting Character Set Attributes',13
         db  ' F5  = Resetting the LaserJet',13
         db  ' F6  = Translation Modes',13
         db  ' F7  = CLASER Sound',13
         db  ' F8  = Graphic Screen Dumps',13
         db  ' F9  = Port Assignment and Other Options',13
         db  ' F10 =  LaserJet Error Codes',13
         db  ' PgUp = previous page',13
         db  ' PgDn = next page',13
         db  ' Home = this screen',0
help1    db  '         Installing the LaserJet',13
         db  'The Hewlett-Packard Laserjet should be',13
         db  'connected to the PC Serial Port with',13
         db  'the supplied cable. Refer to your Guide',13
         db  'to Operations to determine which connec-',13
         db  'tion is the serial port. If there is on-',13
         db  'ly 1 serial port it is usually COM1:,',13
         db  'but if you have 2 serial ports you must',13
         db  'decide which port will have the LaserJet',13
         db  'connected to it.',13
         db  'Any font cartridges must be pushed firm-',13
         db  'ly into the font connector before the',13
         db  'LaserJet is turned on.',13
         db  'You may test the LaserJet by pressing',13
         db  'the TEST PRINT button on the LaserJet.',13
         db  'You may also press the SELF TEST key.',0
help2    db  '         CLASER Startup Options',13
         db  'CLASER.COM is made resident in memory by',13
         db  'entering at the keyboard or in an AUTO-',13
         db  'EXEC.BAT file the command:',13
         db  '   CLASER n q',13
         db  'n is a value of 1,2, or N',13
         db  '   1 = Direct LPT1: to COM1:',13
         db  '   2 = Direct LPT1: to COM2:',13
         db  '   N = Do not reassign LPT1:',13
         db  'If there is a second variable on the',13
         db  'command line (the letter Q) CLASER will',13
         db  'start up in Quiet mode and there will',13
         db  'be no blips or blops.',13
         db  13
         db  'Any other assignments must be made from',13
         db  'one of the CLASER menus.',0
help3    db  '            Calling Up CLASER',13
         db  'Once CLASER is resident it may be called',13
         db  'to the screen by pressing and holding',13
         db  'the Alt and the left shift keys and',13
         db  'then tapping the L key. This will start',13
         db  'the CLASER main menu. You can use the',13
         db  'function keys to perform each of the',13
         db  'options when you need them.',13
         db  'You can always use the ESC key to get',13
         db  'out of the current level of menu.',13
         db  'The Print Screen procedure can be called',13
         db  'by the standard SHIFT-PrtSc but may also',13
         db  'be invoked by pressing Alt-Left shift and',13
         db  'the letter P. You can use Alt-Left Shift',13
         db  'G for Lotus 1-2-3 Graphics screens only.',13
         db  '(Alt LS G will cause problems otherwise)',0
help4    db  '  Primary and Alternate Fonts',13
         db  'You can select the primary and alternate',13
         db  'fonts by selecting F2 or F3 from the',13
         db  'Main Menu. F2 allows font selection from',13
         db  'cartridge 92286B and equivalent. If you',13
         db  'do not have the "B" cartridge you should',13
         db  'run CLFONT.COM which comes with CLASER',13
         db  'to install your cartridge fonts in the',13
         db  'CLASER program. You may also select fonts',13
         db  'by their attributes using option F3. It',13
         db  'is more convenient to install a cartridge',13
         db  'using CLFONT.COM',13
         db  'You can include the SO and SI characters',13
         db  'in you word processing text to switch',13
         db  'between primary and alternate fonts.',13
         db  '   Press PgDn for more information',0
help5    db  '     Font Characteristics',13
         db  'In order of importance, a font is set',13
         db  'by    1) Orientation (Portrait vrs.',13
         db  '         Landscape)',13
         db  '      2) Symbol Set',13
         db  '      3) Proportional vrs. Fixed Spacing',13
         db  '      4) Pitch',13
         db  '      5) Height',13
         db  '      6) Style (Italic vrs. Upright)',13
         db  '      7) Weight (light, medium or bold)',13
         db  '      8) Typeface',13
         db  'Each of these can be selected through F3',13
         db  'from the Main Menu. They are listed there',13
         db  'in order of importance. The LaserJet will',13
         db  'make the best match to your request from',13
         db  'the fonts in the cartridge.',0
help6    db  '         Resetting the LaserJet',13
         db  13
         db  'Pressing  F4 from the main menu will',13
         db  'send the LaserJet Escape-E control',13
         db  'string out to LPT1: which will reset',13
         db  'the Laserjet. This flushes any data in',13
         db  'the buffers and does a page eject if not',13
         db  'already at the top of a page.',13
         db  13
         db  'If your LaserJet is on LPT2: you',13
         db  'must swap ports (see item F8 from main',13
         db  'menu).',13
         db  13
         db  'If you have an Epson or other printer on',13
         db  'LPT1: it will not be reset and is liable',13
         db  'to be confused by using this option.',0
help7    db  '           Translation Modes',13
         db  'CLASER can dynamically translate Epson',13
         db  'escape sequences into HP LaserJet escape',13
         db  'sequences. It can also translate easily',13
         db  'entered code sequences into the escape',13
         db  'codes needed to switch between available',13
         db  'fonts. Function keys F1 and F2 toggle',13
         db  'the emulation ability of CLASER.',13
         db  'Translation functions are only enabled',13
         db  'on LPT1:. If you need one of these func-',13
         db  'ions on the printer on LPT2: you must',13
         db  'swap LPT1: and LPT2: (see function 8).',13
         db  '    (PRESS PgDn for more information)',0
help7a   db  '      Translation Modes (contined)',13
         db  'CLASER will try to emulate certain func-',13
         db  'tions of the Epson FX graphics printers',13
         db  'such as Underlining and Automatic Tabs.',13
         db  'When in Epson Mode, CLASER may become',13
         db  'confused if it receives Escape sequences',13
         db  'which were intended for the LaserJet or',13
         db  'some other non-Epson printer. Some hard-',13
         db  'ware functions such as emphasized, comp-',13
         db  'ressed or enlarged print will not be emu-',13
         db  'lated, just because there is no',13
         db  'equivalent in the LaserJet.',13
         db  'Epson emulation does not automatically',13
         db  'set 66 lines per page. This option must',13
         db  'be set from F9 - Other options',13
         db  '    (PRESS PgDn for more information)',0
help7b   db  '      Translation Modes (contined)',13
         db  'CLASER will emulate Epson graphic modes',13
         db  'but cannot emulate the ability to upload',13
         db  'characters to the Epson. CLASER does not',13
         db  'emulate 9 pin graphics modes. For other',13
         db  'graphics modes CLASER by default uses 75',13
         db  'dots/inch for Epson low resolution, 100',13
         db  'dots/inch for medium resolution, and 150',13
         db  'dots/inch for high resolution modes.',13
         db  'This can be changed by selecting F6 on',13
         db  'the Translation Modes screen. Epson high',13
         db  'resolution modes may appear choppy on',13
         db  'the LaserJet due to rounding errors',13
         db  'in the translation process.',13,13
         db  '    (PRESS PgDn for more information)',0
help7c   db  '      Translation Modes (contined)',13
         db  'CLASER will insert Font changes into the',13
         db  'print stream if you include a tilde (~)',13
         db  'in the text to be printed. The tilde',13
         db  'signals CLASER that a font change is',13
         db  'coming and CLASER waits for the next',13
         db  'character in the print stream. If the',13
         db  'character is a 1 to 9 CLASER will send',13
         db  'out a font change to the LaserJet as if',13
         db  'you had pressed one of the function Keys',13
         db  'F1 to F9 on the Primary Character Set',13
         db  'Selection Menu. If you enter ~1 it is',13
         db  'the same as pressing F1. ~0 is the same',13
         db  'as F10 and ~A or ~B are A or B fonts.',13
         db  'This feature can be enabled or disabled',13
         db  'using F3 and F4 on the translation menu.',0
help8    db  '              CLASER SOUND',13
         db  13
         db  'The blips and blops coming from this',13
         db  'program may be annoying in which case',13
         db  'you may choose to silence them by using',13
         db  'the Q option on starting up or by using',13
         db  'option F6 to turn off the sound.',13
         db  13
         db  'If you use F6 it is a toggle, which means',13
         db  'that each time you use it it reverses',13
         db  'itself from the previous state.',13
         db  13
         db  'One blip means success, one blop means',13
         db  'a wrong key was pressed, and many blops',13
         db  'means that the function failed, usually',13
         db  'because the printer was not turned on.',0
help9    db  '        GRAPHIC PRINT SCREEN',13
         db  'The Shift-PrtSc combination can be set',13
         db  'to produce graphics screen dumps to the',13
         db  'LaserJet. By enabling graphic screen',13
         db  'printing, when the PC is in a valid PC',13
         db  'graphics mode CLASER graphically dumps',13
         db  'to the selected printer. The default',13
         db  'resolution of the graphics is 75 dots/',13
         db  'inch. This most closely approximates the',13
         db  'Epson graphic screen dumps using the DOS',13
         db  'GRAPHICS.COM program except that the',13
         db  'rightmost 1/2 inch is lost. A smaller',13
         db  'graphics dump at 100 dots/inch can be',13
         db  'selected. Ctrl-Left Shift-P can be used',13
         db  'when Shift-PrtSc is disabled.',0
         db  '    (PRESS PgDn for more information)',13
help9a   db  '    GRAPHIC PRINT SCREEN (continued)',13,13
         db  'Lotus 1-2-3 does not use standard PC',13
         db  'graphics modes and using Alt-Left Shift-P',13
         db  'will produce pages of garbled output, but',13
         db  'no graphics. For Lotus 1-2-3 graphics',13
         db  'screens use ALT-Left Shift-G. Use this',13
         db  'combination only for the graphics screens',13
         db  'or you will get some weird output. If you',13
         db  'press Alt-Left Shift-G while in a non-',13
         db  'graphics screen the effect is scary, But',13
         db  'do not panic! It will end after a',13
         db  'moment of strange output.',0
help10    db  '          PORT ASSIGNMENT',13,13
         db  'CLASER replaces the DOS MODE command and',13
         db  'will automatically redirect the printer',13
         db  'output to either COM1: or COM2:. You may',13
         db  'use the F8 Port Assignment screen to set',13
         db  'printer redirection or you may specify',13
         db  'redirection at start-up. Some programs',13
         db  'may reinitialize the COM port. You can',13
         db  'reset the COM ports through the Port',13
         db  'Assignment menu. You may also deselect',13
         db  'the LaserJet. It is also possible to',13
         db  'swap LPT1: and LPT2:. This sends the LPT1:',13
         db  'output to LPT2: and vice-versa.',13
         db  '    (PRESS PgDn for more information)',13
help10a   db  '            OTHER OPTIONS',13
         db  'Several convenient options can be set',13
         db  'on screen F9. Most of these options work',13
         db  'only for the LaserJet, but page eject',13
         db  'and line feed work equally for most',13
         db  'printers.',13
         db  'You may test the current settings by',13
         db  'using the test lines option in F8. This',13
         db  'prints out a few lines to test what the',13
         db  'current settings are. At the end it page',13
         db  'ejects.',13
         db  ' ',13
         db  'Note: all these options assume LPT1:.',13
         db  'you must swap printers using F8 menu to',13
         db  'send these options to LPT2:',0
help11    db  '     UNINSTALLING CLASER',13,13
         db  'Once CLASER is installed in you computers',13
         db  'memory it can be uninstalled by pressing',13
         db  'CTRL and K from any Claser menu. This',13
         db  'will free up you computers memory and',13
         db  'set things to the way things were before',13
         db  'Claser was installed. This may cause a',13
         db  'few problems, as Claser uninstalls all',13
         db  'of the memory resident programs that',13
         db  'were installed after Claser. Claser will',13
         db  'even kill any programs that may have',13
         db  'been running. Be careful when using the',13
         db  'uninstall option.',13,0
help12   db  13,'not installed',0
help13   db  13,'not installed',0
help14   db  '          LaserJet Error Codes',13
         db  '11 - Paper Cassette empty or not loaded',13
         db  '12 - Printer not closed correctly',13
         db  '13 - Paper Jam',13
         db  '14 - EP cartridge not installed correctly',13
         db  '15 - Printing printer self-test',13
         db  'PC - Request for paper cassette',13
         db  '     alternates with paper size',13
         db  'PF - Manual feed request',13
         db  'PE - Envelope feed request',13
         db  'FE - Font cartridge removed - reset',13
         db  'FC - Font cartridge removed - reinsert',13
         db  '20 - Memory overflow',13
         db  '21 - Page formatting not fast enough',13
         db  '22 - Buffer overflow',13
         db  '      Press PgDn for more codes',0
help15   db  '          LaserJet Error Codes',13
         db  '40 - Data error (wrong baud, parity etc)',13
         db  '41 - Temporary page error',13
         db  '50 - Fusing assembly malfunction',13
         db  '51 - Beam Detect malfunction',13
         db  '52 - Scanner Malfunction',13
         db  '53 - Tempature Control Malfunction',13
         db  '54 - Main Motor Malfunction',13
         db  '55 - Printer Command Error',13
         db  '60 - Circuit Malfunction',13
         db  '61 - Checksum Error - program ROM',13
         db  '62 - Checksum Error - Internal Font ROM',13
         db  '63 - Dynamic Ram Error',13
         db  '64 - Scan Buffer Error',13
         db  '65 - D-RAM Controller Error',13
         db  '   Refer to Manual for Solutions',0
cseg   ends
       end
