print macro string
    mov  ah,9
    lea  dx,string
    int  21h
    endm
cseg      segment para public 'CODE'
          assume   cs:cseg,ds:cseg,ss:cseg,es:cseg
          org   100h
entry: jmp  main
mess1  db 'Current Disk is: '
disk1  db '00',13,10
       db 'Changing to: '
disk2  db '00',13,10,'$'
mess3  db 'Current Checksum is: '
checkho   dw 0
       db ' '
checklo   dw  0
          db 13,10
       db 'Changing to: '
checkhn   dw 0
       db ' '
checkln   dw  0
          db 13,10,'$'
err1   db 'disk must be 00 to 99 ',13,10,'$'
fdisk  db 0
main      proc     near
         mov   ax,word ptr ds:[5dh]
         cmp   ah,'0'
         jl    bad_digit
         cmp   al,'0'
         jl    bad_digit
         cmp   ah,'9'
         jg    bad_digit
         cmp   al,'9'
         jle   good_digit
bad_digit:
         print  err1
         int  20h
good_digit:
         mov   word ptr disk2,ax
         and   ax,0f0fh
         mov   dl,ah
         mov   dh,0
         mov   cx,10
         mov   ah,0
         mul   cl
         add   ax,dx
         mov   fdisk,al
         call  get_fdisk
         call  get_chk
         call  set_fdisk
         call  set_chk
         int  20h
get_chk:
         mov  al,2eh
         call  get_cmbyte
         call  hex_it
         mov   checkho,ax
         mov  al,2fh
         call  get_cmbyte
         call  hex_it
         mov   checklo,ax
         ret
set_chk:
; calculate the checksum
    mov   cx,29
    mov   bx,10h
    mov   bp,0
cm_loop:
    push  cx
    mov   ax,bx
    inc   bx
    call  get_cmbyte
    mov   ah,0
    add   bp,ax
    pop   cx
    loop  cm_loop
; bp has the checksum
; ah has the checksum of 2e
    mov   ax,bp
    mov   al,2eh
    call  set_cmbyte
    mov   ah,0
         call  hex_it
         mov   checkhn,ax
    mov  ax,bp
    mov  ah,al
    mov   al,2fh
    call  set_cmbyte
    mov   ah,0
         call  hex_it
         mov   checkln,ax
         print  mess3
         ret
get_fdisk:
; gets the fixed disk byte
         mov  al,12h
         call  get_cmbyte
; convert to hex
         call  hex_it
         mov   disk1,al
         mov   disk1+1,ah
         print  mess1
         ret
set_fdisk:
; gets the fixed disk byte
         mov  al,12h
         mov  ah,fdisk
         call  set_cmbyte
; convert to hex
         ret
set_cmbyte:
         out  70h,al
         mov  al,ah
         out  71h,al
         ret
get_cmbyte:
         out  70h,al
         nop
         nop
         in   al,71h
         ret
hex_it:
         mov  ah,al
         mov  cl,4
         shr  al,cl
         and  ah,0fh
         cmp  ah,9
         or   ax,3030h
         cmp  ah,39h
         jle  ok_ah
         add  ah,7
ok_ah:
         cmp  al,39h
         jle  ok_al
         add  al,7
ok_al:
         ret
main      endp
cseg      ends
          end      entry
