print macro string
   lea dx,string
   mov  ah,9
   int  21h
endm
get macro string
    lea  dx,string
     mov ah,10
    int  21h
    print crlf
endm
cseg      segment para public 'CODE'
          assume   cs:cseg,ds:cseg,ss:cseg,es:cseg
          org   100h
start: jmp  main
hi db  13,10,'ROMU.COM copyright 1988 by Keith P. Graham',13,10
   db 'PC-Rockland BBS (914) 353-2157',13,10,'$'
;            w   b  w  w   b  b 3b b   b
htable0 db 'TYPE '
htable db ' CYL  HD  SWPC ECC CB  LZ   S/T',13,10,'$'
dtable0 db ' 00  '
dtable db ' 0000 000 0000 000 000 0000 000',13,10,'$'
;           012345678901234567890123456789
wmess db 13,10,'Press any key to continue',13,10,'$'
romsize  dw  0
mess1 db 'Enter source of BIOS',13,10
      db '  0. Exit',13,10
      db '  1. F000:8000 AT bios 32K',13,10
      db '  2. F000:0000 AT bios 64k',13,10
      db '  3. 32K BIOS ROM Image file',13,10
      db '  4. 32K Split BIOS ROM Image files (2 16K FILES)',13,10
      db '  5. 64K BIOS ROM Image file',13,10
      db '  6. 64K Split BIOS ROM Image files (2 32K FILES)'
crlf  db  13,10,10,'$'
mess2 db 'Enter What to do with Bios',13,10,10
      db '  0. Return to previous menu',13,10
      db '  1. Display/Edit DISK table',13,10
      db '  2. Display Checksum',13,10
      db '  3. Force Checksum to 0',13,10
      db '  4. Write BIOS Image file',13,10
      db '  5. Write split Bios Image files',13,10
      db '$'
mess2a db '  6. Convert 32k bios to 64k',13,10
      db '$'
mess3 db 'Enter Disk table option',13,10
      db '  0. Return to previous menu',13,10
      db '  1. Display ROM DISK table 1-14',13,10
      db '  2. Display ROM DISK table 16-31',13,10
      db '  3. Display ROM DISK table 32-47',13,10
      db '  4. Display ROM DISK table 48-63',13,10
      db '  5. Change a disk table entry',13,10,10
      db '$'
cmess1 db 'Enter table entry to change. $'
ctab   db 3,0,'    '
cmess2 db 'Enter Number of Cylinders. $'
ccount db 5,0,'     ',0
cmess3 db 'Enter Number of Heads. $'
cmess4 db 'Enter Starting Write Precompensation Cylinder. $'
cmess5 db 'Enter Maximum ECC Data Burst Length. $'
cmess6 db 'Enter Control Byte (normally 0). $'
cmess7 db 'Enter Landing Zone. $'
cmess8 db 'Enter Sectors Per Track. $'
ttable db  16 dup(0)
ynask  db  'Is this data correct? (y/n) $'
yn     db 2,0,'   '
;
fmess1 db 'enter file name: $'
fmess2 db 'enter Low half file name: $'
fmess3 db 'enter High half file name: $'
file1  db  80,0,81 dup(0)
file2  db  80,0,81 dup(0)
handle1  dw 0
handle2  dw 0
emess1   db 7,13,10,'Invalid file or file not found',13,10,10,'$'
sum    db 'Checksum is: '
csum   db '00',13,10,'$'
;
choice1 db 2,0,'  '
;
stack dw 256 dup(0)
bios  dw 0   ;main bios area 64k
wbios dw 0   ;bios work area where the splits are created
main      proc     near
; set up memory so it will work
      print hi
; first fix stack
      lea  sp,stack+510
; shrink down
      lea  bx,last_byte
      add  bx,15
      mov  cl,4
      shr  bx,cl
      mov  ah,4ah
      int  21h
; allocate the blocks
      mov  ah,48h
      mov  bx,1000h ; 64k
      int  21h
      jc   bad_mem
      mov  bios,ax
      mov  ah,48h
      mov  bx,1000h ; 64k
      int  21h
      jc   bad_mem
      mov  wbios,ax
jmp   menu1
bad_mem:
      int  20h
getcount:
; gets a number from 0 to 1000 in ax
      get ccount
    print crlf
      mov  dx,0
      mov  bx,0
      lea  si,ccount+2
      mov  cl,ccount+1
      mov  ch,0
      inc  cx
      cmp  byte ptr ccount+2,13
      je   bad_ct
      cmp  cl,1
      jge  ctloop
bad_ct:
      mov  ax,0
      stc
      ret
ctloop:
      cld
      lodsb
      mov  ah,0
      cmp  al,13
      je   ctend
      cmp  al,20h
      je   cteloop
      and  al,0fh
      cmp  al,9
      jg   bad_ct
      xchg dx,ax
      push cx
      mov  cl,10
      mul  cl
      add  dx,ax
      pop  cx
cteloop:
      loop ctloop
ctend:
      mov  ax,dx
      clc
      ret
menu3:
      print mess3
      get  choice1
      print crlf
      cmp   choice1+2,'0'
      je    menu2a
      cmp   choice1+2,'1'
      je    disp1
      cmp   choice1+2,'2'
      je    disp2
      cmp   choice1+2,'3'
      je    disp3
      cmp   choice1+2,'4'
      je    disp4
      cmp   choice1+2,'5'
      je    ctable
      jmp   menu3
menu2a: jmp menu2
disp1:
      print htable0
      mov   bx,1
      mov   cx,14
      mov   si,0E401h
      jmp   d1loop
disp2:
      mov   bx,16
      print htable0
      mov   cx,16
      mov   si,0E401h+(15*16)
      jmp   d1loop
disp3:
      mov   bx,32
      print htable0
      mov   cx,16
      mov   si,0E401h+(31*16)
      jmp   d1loop
disp4:
      mov   bx,48
      print htable0
      mov   cx,16
      mov   si,0E401h+(47*16)
      jmp   d1loop
menu3b: jmp menu3
ctable:
; table is changed here
; first display table
      print cmess1
      call getcount
      jc   menu3b
      mov  bx,ax
; bx has the count of the guy we want
      cmp  bl,1
      jl    menu3b
      cmp  bl,64
      jg   menu3b
; save the buy for all time
      mov  bp,bx
; now calculate the offset
      mov   cl,4
      mov   ax,bx
      shl   ax,cl
      mov   cx,1
      mov   si,0E401h
      add   si,ax
      sub   si,16
      push  si
; copy up the table line
      lea  di,ttable
      mov  cx,16
      mov  al,0
      cld
      push  ds
      mov   ds,bios
rep   movsb
      pop  ds
      print htable0
      lea  si,ttable
      call  disp_tabc
      mov   ax,bx
      call  decword
      mov   word ptr dtable0+1,ax
      print dtable0
      pop   si
; try and get somebody
      print cmess2
      call  getcount
      jc   gethead
      mov  word ptr ttable,ax
gethead:
      print cmess3
      call  getcount
      jc   getswpc
      mov  byte ptr ttable+2,al
getswpc:
      print cmess4
      call  getcount
      jc   getecc
      mov  word ptr ttable+5,ax
getecc:
      print cmess5
      call  getcount
      jc   getcb
      mov  byte ptr ttable+7,al
getcb:
      print cmess6
      call  getcount
      jc   getlz
      mov  byte ptr ttable+8,al
getlz:
      print cmess7
      call  getcount
      jc   getspt
      mov  word ptr ttable+12,ax
getspt:
      print cmess8
      call  getcount
      jc   disptemp
      mov  byte ptr ttable+14,al
disptemp:
      print htable0
      lea  si,ttable
      mov  bx,bp
      call  disp_tabc
      mov   ax,bx
      call  decword
      mov   word ptr dtable0+1,ax
      mov   cx,1
      print dtable0
      print ynask
      get yn
      print crlf
      cmp  yn+2,'Y'
      je   yes3
      cmp  yn+2,'y'
      je   yes3
      jmp   menu3
yes3:
; copy the stuff back into the table area
; now calculate the offset
      mov   cl,4
      mov   ax,bp
      shl   ax,cl
      mov   cx,1
      mov   di,0E401h
      add   di,ax
      sub   di,16
      lea   si,ttable
      mov   cx,16
      cld
     push  es
     mov   es,bios
     rep  movsb
     pop  es
     jmp  menu3
d1loop:
      push  cx
      call  disp_tab
      mov   ax,bx
      call  decword
      mov   word ptr dtable0+1,ax
      print dtable0
      inc   bx
      pop   cx
      loop  d1loop
      call  waiter
menu3a:
      jmp   menu3
menu2:
      print mess2
      cmp  romsize,0
      jne  no_6
      print  mess2a
no_6:
      get  choice1
      print crlf
      cmp   choice1+2,'0'
      je    menu1
      cmp   choice1+2,'1'
      je    menu3a
      cmp   choice1+2,'2'
      je    do_checksum
      cmp   choice1+2,'3'
      je    do_fchecksum
       cmp  choice1+2,'4'
       je   write_imagea
       cmp  choice1+2,'5'
       je   write_simagea
       cmp  romsize,0
       jne  menu2
       cmp  choice1+2,'6'
       je   make_64k
      jmp   menu2
make_64k:
      mov  romsize,64
      push es
      mov  cx,4000h
      mov  ax,0
      mov  di,0
      mov  es,bios
      cld
rep   stosw
      pop   es
      jmp   menu2
write_imagea: jmp write_image
write_simagea: jmp write_simage
do_fchecksum:
      call   checksum
      push   ds
      mov    ds,bios
      sub    byte ptr ds:0ffffh,dl
      pop    ds
do_checksum:
      call   checksum
      mov    word ptr csum,ax
      print  sum
      jmp    menu2
menu1:
      mov  romsize,0
       print mess1
       get choice1
       print crlf
       cmp choice1+2,'0'
       jne  not_0
       int  20h
not_0:
       cmp  choice1+2,'1'
       je   read_bios
       cmp  choice1+2,'2'
       je   read_biosb
       cmp  choice1+2,'3'
       je   get_imagea
       cmp  choice1+2,'4'
       je   get_simagea
       cmp  choice1+2,'5'
       je   get_imageab
       cmp  choice1+2,'6'
       je   get_simageab
       jmp  menu1
get_simagea: jmp get_simage
get_imagea: jmp get_image
get_simageab:
      mov  romsize,64
       jmp get_simage
get_imageab:
      mov  romsize,64
       jmp get_image
read_biosb:
      mov  romsize,64
read_bios:
       push ds
       push es
       mov  es,bios
       mov  ax,0f000h
       mov  si,0
       mov  di,0
       mov  cx,8000h
       mov  ds,ax
       cld
rep   movsw
       pop   es
       pop   ds
       jmp   menu2
write_image:
; write the image file out
      print fmess1
      get  file1
      mov  bl,file1+1
      mov  bh,0
      mov  ds:file1[bx+2],0
      lea  dx,file1+2
      mov  ah,3ch ; create
      mov  al,0  ; read only
      mov  cx,0  ; normal attribs
      int  21h
      jnc  good_open4
bad_file4:
      print emess1
      jmp  menu1
good_open4:
      mov  handle1,ax
      cmp  romsize,0
      je   write_half
      mov  handle1,ax
      mov  bx,handle1
      mov  dx,0
      mov  cx,8000h
      mov   ah,40h
      push  ds
      mov   ds,bios
      int   21h
      pop   ds
      cmp   ax,8000h
      jne   bad_file4
write_half:
      mov  bx,handle1
      mov  dx,8000h
      mov  cx,8000h
      mov   ah,40h
      push  ds
      mov   ds,bios
      int   21h
      pop   ds
      cmp   ax,8000h
      jne   bad_file4
      mov   bx,handle1
      mov   ah,3eh
      int  21h
      jmp   menu2
get_image:
      print fmess1
      get  file1
      mov  bl,file1+1
      mov  bh,0
      mov  ds:file1[bx+2],0
      lea  dx,file1+2
      mov  ah,3dh ; read input
      mov  al,0  ; read only
      int  21h
      jnc  good_open1
bad_file:
      print emess1
      jmp  menu1
good_open1:
      mov  handle1,ax
      cmp  romsize,0
      je   next_8
      mov  bx,handle1
      mov  dx,0
      mov  cx,8000h
      mov   ah,3fh
      push  ds
      mov   ds,bios
      int   21h
      pop   ds
      cmp   ax,8000h
      jne   bad_file
next_8:
      mov  bx,handle1
      mov  dx,8000h
      mov  cx,8000h
      mov   ah,3fh
      push  ds
      mov   ds,bios
      int   21h
      pop   ds
      cmp   ax,8000h
      jne   bad_file
      mov   bx,handle1
      mov   ah,3eh
      int  21h
      jmp   menu2
get_simage:
      print fmess2
      get  file1
      mov  bl,file1+1
      mov  bh,0
      mov  ds:file1[bx+2],0
      lea  dx,file1+2
      mov  ah,3dh ; read input
      mov  al,0  ; read only
      int  21h
      jnc  good_open2
bad_file2:
      print emess1
      jmp  menu1
good_open2:
      mov  handle1,ax
      mov  cx,4000h
      mov  dx,04000h
      cmp  romsize,0
      je   not_full
      mov  cx,8000h
      mov  dx,00000h
not_full:
      mov  bx,handle1
      mov   ah,3fh
      push  ds
      mov   ds,wbios
      int   21h
      pop   ds
      cmp   ax,cx
      jne   bad_file2
      mov   bx,handle1
      mov   ah,3eh
      int  21h
; next guy
      print fmess3
      get  file1
      mov  bl,file1+1
      mov  bh,0
      mov  ds:file1[bx+2],0
      lea  dx,file1+2
      mov  ah,3dh ; read input
      mov  al,0  ; read only
      int  21h
      jnc  good_open3
bad_file3:
      print emess1
      jmp  menu1
good_open3:
      mov  handle1,ax
      mov  cx,4000h
      mov  dx,0c000h
      cmp  romsize,0
      je   not_full2
      mov  cx,8000h
      mov  dx,8000h
not_full2:
      mov  bx,handle1
      mov   ah,3fh
      push   ds
      mov   ds,wbios
      int   21h
      pop   ds
      cmp   ax,cx
      jne   bad_file3
      mov   bx,handle1
      mov   ah,3eh
      int  21h
      call  unsplit  ; does the unsplitting
      jmp   menu2
write_simage:
      call  split
      print fmess2
      get  file1
      mov  bl,file1+1
      mov  bh,0
      mov  ds:file1[bx+2],0
      lea  dx,file1+2
      mov  ah,3ch ; create
      mov  al,0  ; read only
      mov  cx,0
      int  21h
      jnc  good_open5
bad_file5:
      print emess1
      jmp  menu1
good_open5:
      mov  handle1,ax
      mov  cx,4000h
      mov  dx,4000h
      cmp  romsize,0
      je   not_full3
      mov  cx,8000h
      mov  dx,0
not_full3:
      mov  bx,handle1
      mov   ah,40h
      push  ds
      mov   ds,wbios
      int   21h
      pop   ds
      cmp   ax,cx
      jne   bad_file5
      mov   bx,handle1
      mov   ah,3eh
      int  21h
; next guy
      print fmess3
      get  file1
      mov  bl,file1+1
      mov  bh,0
      mov  ds:file1[bx+2],0
      lea  dx,file1+2
      mov  ah,3ch ; create
      mov  al,0  ; read only
      mov  cx,0
      int  21h
      jnc  good_open6
bad_file6:
      print emess1
      jmp  menu1
good_open6:
      mov  handle1,ax
      mov  cx,4000h
      mov  dx,0c000h
      cmp  romsize,0
      je   not_full4
      mov  cx,8000h
      mov  dx,8000h
not_full4:
      mov  bx,handle1
      mov   ah,40h
      push  ds
      mov   ds,wbios
      int   21h
      pop   ds
      cmp   ax,cx
      jne   bad_file6
      mov   bx,handle1
      mov   ah,3eh
      int  21h
      call  unsplit
      jmp   menu2
checksum:
; sum the at bios
         mov  si,8000h
         mov  cx,8000h
         cmp  romsize,0
         je   not_full5
         mov  si,0
         mov  cx,0ffffh
not_full5:
         cld
         mov  dl,0
         push  ds
         mov   ds,bios
bloop:
         lodsb
         add  dl,al
         loop bloop
         cmp   es:romsize,0
         je    not_full6
         lodsb
         add  dl,al
not_full6:
         pop   ds
;     dl has the checksum
         mov   al,dl
         mov   ah,0
do_hex:
; converts the guy in al to ax 2 hex digits
         mov  cl,16
         div  cl
         or   ax,3030h
         cmp  al,39h
         jle  okal
         add  al,7
okal:
         cmp  ah,39h
         jle  okah
         add  ah,7
okah:
         ret
split:
     mov  si,0
     mov  di,si
     mov  cx,8000h
     cld
     push  ds
     push  es
     mov   es,wbios
     mov   ds,bios
sloop:
     lodsw
     mov   es:[di+8000h],ah
     stosb
     loop sloop
     pop  es
     pop  ds
     ret
unsplit:
     mov  si,0
     mov  di,0
     mov  cx,8000h
     cld
     push  ds
     push  es
     mov   es,bios
     mov   ds,wbios
usloop:
     mov  ah,ds:[si+8000h]
     lodsb
     stosw
     loop  usloop
     pop  es
     pop  ds
     ret
waiter:
    print wmess
    mov  ah,0
    int  16h
    ret
disp_tab:
; displays a singel entry from BIOS segment
; si points to entry
      push  ds
      mov   ds,bios
      push  si
      cld
      lodsw ; cyl
      call  decword
      mov  word ptr es:dtable+1,dx
      mov  word ptr es:dtable+3,ax
      lodsb  ; heads
      mov   ah,0
      call  decword
      mov   byte ptr es:dtable+6,dh
      mov  word ptr es:dtable+7,ax
      lodsw ; not used
      lodsw ; swpc
      call  decword
      mov  word ptr es:dtable+10,dx
      mov  word ptr es:dtable+12,ax
      lodsb  ; ecc
      mov   ah,0
      call  decword
      mov   byte ptr es:dtable+15,dh
      mov  word ptr es:dtable+16,ax
      lodsb  ; control byte
      mov   ah,0
      call  decword
      mov   byte ptr es:dtable+19,dh
      mov  word ptr es:dtable+20,ax
      add si,3 ; skip 3
      lodsw  ; landing zone
      call  decword
      mov   word ptr es:dtable+23,dx
      mov  word ptr es:dtable+25,ax
      lodsb  ; sectors/track
      mov   ah,0
      call  decword
      mov   byte ptr es:dtable+28,dh
      mov  word ptr es:dtable+29,ax
      pop  si
       add  si,16
      pop   ds
      ret
disp_tabc:
; displays a singel entry from current segment
; si points to entry
      push  si
      cld
      lodsw ; cyl
      call  decword
      mov  word ptr dtable+1,dx
      mov  word ptr dtable+3,ax
      lodsb  ; heads
      mov   ah,0
      call  decword
      mov   byte ptr dtable+6,dh
      mov  word ptr dtable+7,ax
      lodsw ; not used
      lodsw ; swpc
      call  decword
      mov  word ptr dtable+10,dx
      mov  word ptr dtable+12,ax
      lodsb  ; ecc
      mov   ah,0
      call  decword
      mov   byte ptr dtable+15,dh
      mov  word ptr dtable+16,ax
      lodsb  ; control byte
      mov   ah,0
      call  decword
      mov   byte ptr dtable+19,dh
      mov  word ptr dtable+20,ax
      add si,3 ; skip 3
      lodsw  ; landing zone
      call  decword
      mov   word ptr dtable+23,dx
      mov  word ptr dtable+25,ax
      lodsb  ; sectors/track
      mov   ah,0
      call  decword
      mov   byte ptr dtable+28,dh
      mov  word ptr dtable+29,ax
      pop  si
       add  si,16
      ret
;
;            w   b  b  w   b  b 3b b  b
;table db ' CYL  HD  SWPC ECC CB  LZ   S/T',13,10,'$'
;table db ' 0000 000 0000 000 000 0000 000',13,10,'$'
;          012345678901234567890123456789
decword:
; converts a word in ax to a decimal in DX:AX
      cmp  ax,0
      mov  dx,0
      jl   dc_neg
      mov  cx,100
      div  cx
      mov  cx,10
      div  cl
      xchg ax,dx
      div  cl
dc_neg:
      or ax,3030h
      or dx,3030h
; ax has the low, dx, the high
      ret
main      endp
last_byte equ this byte
cseg      ends
          end      start
