; this takes stuff out of curr_buffer and puts in targ_buff
cseg segment para public 'CODE'
assume cs:cseg,ds:cseg,es:cseg
extrn  curr_buff:word,curr_buff_size:word
extrn  targ_buff:word,targ_buff_size:word
;
occ   db 512 dup(0)
buff1  dw 0
buff2  dw 0
ada proc near
public ada
      mov   cx,curr_buff_size
      mov   si,0
      mov   di,0
      cld
      push  ds
      push  es
      mov   es,targ_buff
      mov   ds,curr_buff
rep   movsb
      pop   es
      pop   ds

; first determine freuqnecy table
      lea  di,occ
      mov  ax,0
      mov  cx,256
      cld
rep   stosb
; no pass the data adding it all up
      mov   cx,curr_buff_size
      mov   si,0
      cld
      push  ds
      mov   ds,curr_buff
      mov   ah,0
count_loop:
      lodsb
      mov   bx,ax
      shl   bx,1
      inc   word ptr es:occ[bx]
      loop   count_loop
      pop   ds
; now find the most frequent flier
      mov   dx,0
      mov   bx,0
      lea   si,occ
      mov   cx,256
      mov   di,0
freq_loop:
      lodsw
      cmp   ax,bx
      jl    not_most_freq
      mov   bx,ax
      mov   dx,di
not_most_freq:
      inc   di
      loop   freq_loop
; all done, dl has the most frequent guy
;
; first clean up the occ table, the obvious choice for most often
; has got to be 0
      mov   ax,targ_buff
      mov   buff1,ax
      mov   ax,curr_buff
      mov   buff2,ax
      mov   dh,0
ada_top:
      mov   bp,0
; the following swaps buffers. the first time
; we are running off of curr_buff to targ_buff
      mov   ax,buff2
      xchg  ax,buff1
      mov   buff2,ax
      lea   di,occ
      mov   cx,256
      mov   al,0
      cld
rep   stosb
; now set up the pointers to run through the adaptave stuff
;
        push   ds
        push   es
        mov    cx,curr_buff_size
        mov    es,buff2
        mov    ds,buff1
        mov    di,cx
        dec    di
        mov    si,0
;
     mov   bh,0
fol_top:
     cld
     lodsw
     dec si
     std
     stosb
     cld
fol_fol:
     cmp   cx,1
     jle   bot_fol
     mov   bl,al
     cmp   ah,0
     je    make_fol
     cmp   byte ptr cs:occ[bx],ah    ; match means that follower is tabled
     jne   make_fol
     cmp   ah,dl
     je    make_fol
; here we have to do a follower
; precursor is in output, put in new follower
;  ah has the old follower
     mov   al,dl
     std
     stosb
     cld
     inc   bp
     lodsw
     dec si
     dec   cx
     jmp   fol_fol
make_fol:
     mov   byte ptr cs:occ[bx],ah
bot_fol:
     loop  fol_top
;
;
        pop  es
        pop  ds
        inc   dh
        cmp   bp,0
        je     end_ada1
        cmp   dh,40
        je     end_ada1
        jmp   ada_top
end_ada1:
      cld
      mov    cx,curr_buff_size
      push   ds
      push   es
      mov    es,targ_buff
      mov    ds,buff2
      mov    si,0
      mov    di,0
      shr    cx,1
      mov    bx,dx
end_ada_loop:
      lodsw
      xchg   ax,bx
      stosw
      loop   end_ada_loop
      mov    ax,bx
      stosw
      pop    es
      pop    ds
      mov    targ_buff_size,di
      ret
ada   endp
cseg  ends
     end
