CSEG SEGMENT PARA PUBLIC 'CODE'
assume cs:CSEG,ds:CSEG,es:cseg,ss:cseg
extrn menu:byte,lines:word,menu_lines:word,title_length:word
extrn menu_length:word,title_lines:word
extrn blop:near
;
menu_di  dw  0
vbuff dw	0b800h
top_line   dw  0
bot_line   dw  0
public menu_di,vbuff,top_line,bot_line
f1	db 'F1 - Help',0
escx    db 'Esc - Exit',0
instruct db 'Use  arrows to select item and press ENTER',0
hello db 'GMENU - Ver. 2.1, (C) Copyright 1991 Keith P. Graham',0
crit  db 'A critical errorr has occurred. '
      db '1=abort, 2=Retry, 3=Exit Gmenu',0
;
crit_mess:
 public crit_mess
	push	es
	mov	es,vbuff
	mov	di,(24*160)+8
	mov	cx,80
	mov	ax,3f20h
	cld
	rep	stosw
	mov	di,(24*160)+8
	mov	si,offset crit
	call printat
crit_loop:
        call  blop
        call  blop
        mov   ah,0
        int   16h
        cmp   al,31h
        jl    crit_loop
        cmp   al,33h
        jg    crit_loop
exit_crit:
        push   ax
	mov	di,(24*160)+8
	mov	cx,80
	mov	ax,3f20h
	cld
	rep	stosw
        pop     ax
     pop  es
     ret
showmenu:
public showmenu
        call    do_back
        call    do_back1
	push	es
	mov	es,vbuff
; title starts at third line
; title_length and title_lines have the box size
	mov	cx,title_lines
	mov	di,3*80*2	; start on third line
	mov	dx,78
	sub	dx,title_length
	and	dx,02feh
	add	di,dx
        mov     bp,title_length
        call    blank_area
	mov	si,lines
        mov     bx,99
	call	printat
; no make a place for the menu item
        mov     ax,21
        sub     ax,title_lines
        sub     ax,menu_lines
        shr     ax,1
; ax has the number of lines to space after top stuff
        add     ax,title_lines
        add     ax,3
        mov     cx,160
        mul     cx
  	mov	cx,menu_lines
        mov     di,ax
	mov	dx,78
	sub	dx,menu_length
	and	dx,02feh
	add	di,dx
        mov     bp,menu_length
        call    blank_area
        mov     bx,2
        mov     cx,menu_lines
        inc     di
        inc     di
        mov     menu_di,di
show_items:
        push    cx
        push    di
        push    bx
        mov     si,lines[bx]
	call	printat
        pop     bx
        pop     di
        pop     cx
        add     di,160
        inc     bx
        inc     bx
        loop    show_items
	pop	es
; calculate the top line of menu
        mov     ax,menu_di
        mov     dx,0
        mov    cx,160
        div    cx
        mov    top_line,ax
        add    ax,menu_lines
        mov    bot_line,ax
	ret
do_back1:
	push	es
	mov	es,vbuff
; now put the words on
	mov	di,4
	mov	si,offset hello
	call printat
	mov	di,(24*160)+4
	mov	si,offset instruct
	call printat
	mov	di,(24*160)+110
	mov	si,offset f1
	call printat
	mov	di,(24*160)+138
	mov	si,offset escx
	call printat
        pop     es
        ret
do_back:
public do_back
	push	es
	mov	es,vbuff
	mov	di,0
	mov	cx,60
	mov	ax,3920h
	cld
	rep	stosw
	mov	di,112
	mov	cx,24
	mov	ax,3020h
	cld
	rep	stosw
	mov	cx,23*80
	mov	ah,1fh
	mov	al,176
	rep	stosw
	mov	cx,80
	mov	ax,3f20h
	cld
	rep	stosw
        pop     es
        ret
blank_area:
public blank_area
; this makes a blank area
	push	di	; save for later
        push    cx
        mov     bx,0
        sub     di,162  ; back a line
; top line
        mov     ah,1eh
        mov     al,''
        stosw
        mov     cx,bp
        mov     al,''
        inc     cx
        rep     stosw
        mov     al,''
        stosw
        pop     cx
        pop     di
        push    di
tline_loop:
	push	cx
	push	di
        dec     di
        dec     di
	mov	cx,bp
	inc	cx
        mov     ah,1eh
        mov     al,''
        stosw
	mov	al,20h
	cld
	mov	ah,1fh
	rep	stosw
        mov     ah,1eh
        mov     al,''
        stosw
        mov     ah,07h
	mov	al,176
        stosw
	pop	di
	add	di,160
	pop	cx
	loop	tline_loop
        push    di
        dec     di
        dec     di
        mov     ah,1eh
        mov     al,''
        stosw
        mov     cx,bp
        mov     al,''
        inc     cx
        rep     stosw
        mov     al,''
        stosw
        mov     ah,07h
	mov	al,176
        stosw
        pop     di
	add	di,160
        mov     ah,07h
	mov	al,176
	mov	cx,bp
	inc	cx
	inc	cx
	inc	cx
	rep	stosw
	pop	di
        ret
printat:
public printat
; si is source, di is location
; if centered, bx=99
	mov	dx,di
        cmp     bx,99
        jne     printat0
; center lines by
        call    get_center
printat0:
	cld
	lodsb
	cmp	al,0
	je	end_p
        cmp     al,'&'
        je      highlight
	cmp	al,10
	je	new_line
	cmp	al,13
	je	printat0
	stosb
	inc	di
	jmp	printat0
highlight:
        lodsb
        mov     ah,byte ptr es:[di]+1
        and     ah,1ch
        or      ah,0ch
        stosw
        jmp     printat0
new_line:
	mov	di,dx
	add	di,160
	mov	dx,di
        cmp     bx,99
        jne     printat0
; center lines by
        call    get_center
	jmp	printat0
no_line:
	inc	di
	inc	di
	jmp	printat0
end_p:
	ret
get_center:
        push    cx
        mov     cx,title_length
        inc     cx
        inc     cx
        push    si
search_c:
        cmp     byte ptr ds:[si],10
        je      found_center
        dec     cx
        inc     si
        jmp     search_c
found_center:
        pop     si
        and     cx,02feh
        add     di,cx
        pop     cx
        ret
CSEG ENDS
	end

