cseg      segment para public 'CODE'
          assume   cs:cseg,ds:cseg,ss:cseg,es:cseg
          org      100h     ;end of program segment prefix
enter:    jmp      install  ;skip over data
;
video     dw  2000 dup(0)
listname  db  80 dup(0),0
getparm   db  64
listfile  db  0,64 dup(' ')
badmess  db  'Bad File name or File not found, job cancelled',13,10,'$'
getmess   db  13,10,'Enter parameters: $'
dta       dw  0
          dw  0
oldpsp    dw  0
bhpage    db  0
cursor    dw  0
cursmode  dw  0
int22     dd  0
handle    dw  0
listsize  dw  0
psploc    dw  0  ; segment of new psp
savespe   dw  0  ; local only
savesp    dw  0
savess    dw  0
stack     dw  512  dup(0)
pblock    dw  0
          dw  listfile
es1       dw  0
          dw  5ch
es2       dw  0
          dw  6ch
es3       dw  0
int9      dd  0
int9ip   equ word ptr int9
int9cs   equ word ptr int9 + 2
semaphore db  0
;
;
main      proc     near
          mov      ax,cs
          mov      ds,ax
          mov      es,ax
          mov      savespe,sp
; this is the procedure to load and execute list
          call     get_parm ; asks for an execution parameter
; get old psp and save it
          mov      ax,5100h
          mov      bx,0
          int      21h
          mov      oldpsp,bx
          mov      ax,5000h
          mov      bx,cs
          int      21h
; get old dta
          push     es
          mov      ah,2fh
          int      21h
          mov      dta,bx
          mov      dta+2,es
          pop      es
; execute the file
; have to de-allocate the 64k so that dos will use it
; get rid of the psp memory (if still allocated)
          push    es
          mov     es,psploc
          mov     ah,49h
          int     21h
          pop     es
;
          lea     bx,pblock
          lea     dx,listname
          mov     ax,4b00h
          int     21h
return:
          mov     al,20h
          out     20h,al
          mov     ax,cs
          mov     ss,ax
          mov     sp,cs:savespe
          mov     ds,ax
          mov     es,ax
; re-allocate the lost  memory block
; shrink down
          lea  bx,listloc
          add  bx,15
          mov  cl,4
          shr  bx,cl
          mov  ah,4ah
          int  21h
; now reserve 64k for the program
          mov  ah,48h
          mov  bx,01000h  ;  64k
          int  21h
          mov  psploc,ax  ; assume its there for the taking
; reset the psp stuff
          mov      ax,5000h
          mov      bx,oldpsp
          int      21h
; reset dta
          push     ds
          mov   ax,dta+2
          mov   dx,dta
          mov   ds,ax
          mov   ah,1ah
          int   21h
          pop   ds
          ret
main      endp
getcurs   proc  near
; get video state
          mov ah,15
          int 10h
          mov bhpage,bh
          mov ah,3
          mov bh,bhpage
          int  10h
          mov  cursor,dx
          mov  cursmode,cx
          ret
getcurs   endp
retcurs   proc  near
          mov ah,2
          mov  dx,cursor
          mov bh,bhpage
          int  10h
          ret
retcurs   endp
retscr   proc  near
      push es
      call getvid
      mov  es,ax
      mov  cx,2000
      cld
      mov  di,0
      lea  si,video
rep   movsw
      pop  es
       ret
retscr   endp
getscr   proc  near
      push ds
      call getvid
      mov  ds,ax
      mov  cx,2000
      cld
      mov  si,0
      lea  di,video
rep   movsw
      pop  ds
       ret
getscr   endp
getvid   proc  near
; returns with video buffer in ax
         push  es
         mov   ax,40h
         mov   es,ax
         mov   ax,0b800h
         test  word ptr es:[10h],30h
         jnz    m3
         mov   ah,0b0h
m3:
         pop   es
         ret
getvid   endp
setres  proc  near
keyboard:
; we are entering here due to a key being struck
; first check the keyboard area to see if the CTRL and ALT are pressed
;
        cmp  cs:semaphore,0
        jne  gotoint9
        push ax
        mov  ah,2
        int  16h
        and  al,10
        cmp  al,10
        pop  ax
        je   gotshift
gotoint9:
        jmp  cs:int9
gotshift:
        pushf
        call cs:int9
gotac:
   ; check to see if the next key to come in is B  scan 48
        push ax
        mov  ah,1
        int  16h
        cmp  ah,30h
        pop  ax
        je   goforit
        iret
goforit:
; save the stack
        push ax
        mov  cs:savess,ss
        mov  cs:savesp,sp
; set up the stack
        mov  ax,cs
        mov  ss,ax
        lea  sp,cs:stack+1022
; save the world
        sti
        push bx
        push cx
        push dx
        push si
        push di
        push bp
        push ds
        push es
; get the p so others won't be messed up
        mov  ah,0
        int  16h
        mov  ax,cs
        mov  ds,ax
        mov  es,ax
        mov   semaphore,1
        cld
        call getcurs
        call getscr
;  here we are all set
        call  main
        mov   ax,cs
        mov   ds,ax
        mov   es,ax
exit_prog:
        call retscr
        call retcurs
        pop  es
        pop  ds
        pop  bp
        pop  di
        pop  si
        pop  dx
        pop  cx
        pop  bx
        mov   ss,cs:savess
        mov   sp,cs:savesp
        pop  ax
        mov   cs:semaphore,0
        iret
get_parm:
; get the parameters and set the psp information where it belongs
          lea   dx,getmess
          mov   ah,9
          int   21h
          lea   dx,getparm
          mov   ah,10
          int   21h
          inc   listfile
          ret
setres    endp
listloc   equ  this byte
makeres   proc     near
set_parm:
; gets the parameter and puts it in listfile
          mov  si,80h
          lea  di,listname
          mov  ah,0
          lodsb
          cmp  al,2
          jg   got_name
badfile:
          lea  dx,badmess
          mov  ah,9
          int  21h
          int  20h
got_name:
          mov  cx,ax
gn_loop:
          lodsb
          cmp  al,' '
          je   bot_gn
          cmp  al,13
          je   end_gn
          stosb
bot_gn:
          loop gn_loop
end_gn:
          ret
get_psp:
; shrink down
          lea  bx,listloc
          add  bx,15
          mov  cl,4
          shr  bx,cl
          mov  ah,4ah
          int  21h
; now reserve 64k for the program
          mov  ah,48h
          mov  bx,01000h  ;  64k
          int  21h
          mov  psploc,ax  ; assume its there for the taking
          ret
; this performs the actual installation of interrupts etc
;
install:
          lea      sp,stack+1022
          call     set_parm      ; get com line paramters
          call     get_psp  ; shrinks dos down and sets up exec
          mov      es1,ds
          mov      es2,ds
          mov      es3,ds
; we have the fool thing set up, now to make it resident
; keyboard
        mov   ax,3509h
        int   21h
        mov   int9cs,es
        mov   int9ip,bx
        mov   ah,25h
        mov   al,9h
        lea   dx,keyboard
        int   21h
        lea   dx,makeres
        int 27h
makeres   endp
cseg      ends
          end      enter
