;
print macro string
      lea   dx,string
      mov   ah,9
      int   21h
     endm
dseg      segment para public 'DATA'
   assume ds:dseg
extrn ihandle:word,ohandle:word,hline
filesize dw  0
heading1   db  128 dup(0)
heading2   db  128 dup(0)
dseg ends
cseg  segment para public 'CODE'
      assume   cs:cseg,ds:dseg
make_com:
public make_com:
; this section creates the COM file
;
; start by creating a heading
;
; find the length of the heading by counting back from the end
;
      lea   di,hline+79
      mov   bx,0  ; heading length
      mov   al,20h
      std
      mov   cx,80
repe  scasb
      je    no_heading
      mov   cx,di
      lea   si,hline
      sub   cx,si
      inc   cx
      cmp   cx,0
      jle   no_heading
do_heading:
; have to center the heading
      mov   bx,cx
      sub   bx,80
      neg   bx
      shr   bx,1
      lea   di,heading1
      add   di,bx
      lea   si,hline
rep       movsb
no_heading:
; now we have to figure out where to read
; file goes in buffer
      push  ds
      mov   bx,ihandle
      mov   ax,3f00h
      mov   cx,0ffffh   ; 64k - 1
      mov   dx,0
      mov   ds,buffer
      int   21h
      pop   ds
      jnc    good_read
bad_read:
      jmp    bad_file
good_read:
      cmp    ax,0
      je     bad_read
      cmp    ax,1
      je     bad_read
      mov    filesize,ax
; close the file
      mov    bx,ihandle
      mov    ah,3eh
      int    21h
;
;
;
; set up the table entries
      mov    bx,filesize
      lea    bx,text
      add    ax,bx
      lea    bx,textab
      mov    ds:[bx],ax
      mov    di,ax       ; di has where the table information goes
      lea    si,text
      mov    cx,cs:filesize
      mov    ax,si
      stosw
      lea    bx,texlen
      mov    word ptr ds:[bx],1 ;texlen will have the count of lines
text_loop:
      lodsb
;       cmp    al,1ah
;       je     done_text
      cmp    al,13
      je     new_line
      cmp    al,10
      je     line_feed
      jmp    end_text_loop
new_line:
      cmp    byte ptr ds:[si],10
      jne    line_feed
      lodsb
      loop   line_feed
      jmp    done_text
line_feed:
      mov    ax,si
      stosw
      inc    word ptr ds:[bx]
end_text_loop:
      loop   text_loop
done_text:
;
; move the heading into the correct place
       lea   di,heading
       lea   si,heading1
       push  ds
      mov  ax,cs
       mov   ds,ax
       mov   cx,80
rep      movsb
       pop   ds
       mov   ax,cs:filesize
       lea   bx,filesize2
       mov   ds:[bx],ax
; easier than I thought
; now have to write out the file
      lea    bx,texlen
       mov   ax,word ptr ds:[bx]
       shl   ax,1
       add   ax,cs:filesize
       lea   bx,text
       add   ax,bx
       sub   ax,100h
       mov   dx,100h
       mov   cx,ax
       mov   bx,cs:outhandle
       mov   ah,40h
       mov   al,0
       int   21h
; close the file
      mov    bx,cs:outhandle
      mov    ah,3eh
      int    21h
      mov    ax,cs
      mov    ds,ax
      mov    es,ax
;
;
      int   20h
start  endp
      last_byte equ this byte
cseg   ends
cseg2     segment para public 'CODE2'
      assume   cs:cseg2,ds:cseg2,es:cseg2
      org      100h     ;end of program segment prefix
if com
; set up a local sistack
      lea  sp,sistack+1022
call     main
      mov   ax,4c00h
      int   21h
      int   20h
 db 'TXT2COM Conversion utility. Vers 2.06',13,10
 db 'Copyright 1988 by Keith P. Graham',13,10
 db 'This file cannot be distributed for SALE without',13,10
 db 'express written permission from Keith P. Graham',13,10
 db '238 Germonds Road, W. Nyack, NY 10994, (914) 623-4161',13,10
 db 'To view the contents of this file',13,10
 db 'enter the name of the file from the DOS prompt.',13,10,1ah
pause db 13,10,'Press any key to continue.......$'
endif
if com
err0  db 7,'Wrong video mode, cannot display text',13,10,'$'
endif
if res
      jmp setpass
 db 'TXT2RES Conversion utility. Vers 2.06',13,10
 db 'Copyright 1988 by Keith P. Graham',13,10
 db 'This file cannot be distributed for SALE without',13,10
 db 'express written permission from Keith P. Graham',13,10
 db '238 Germonds Road, W. Nyack, NY 10994, (914) 623-4161',13,10
      db  'Next 4 bytes are scan1,shift1,scan2,shift2:'
scan1   db 14h     ; these are the hot key combinations
shift1  db 10      ; scan being the scan code and shift being
scan2   db 83h     ; the shift state.
shift2  db 12      ;
 db 1ah
endif
if pas
      jmp setpass
 db 'TXT2PAS Conversion utility. Vers 2.06',13,10
 db 'Copyright 1988 by Keith P. Graham',13,10
 db 'This file cannot be distributed for SALE without',13,10
 db 'express written permission from Keith P. Graham',13,10
 db '238 Germonds Road, W. Nyack, NY 10994, (914) 623-4161',13,10
      db  'Next 4 bytes are scan1,shift1,scan2,shift2:'
scan1   db 14h     ; these are the hot key combinations
shift1  db 10      ; scan being the scan code and shift being
scan2   db 83h     ; the shift state.
shift2  db 12      ;
 db 1ah
err2  db 'This is a Pass Through program. You use it execute other',13,10
      db 'programs. The hot key combination to start up the text',13,10
      db 'display will be in effect only while the second program',13,10
      db 'is running. You start this Pass Through program by',13,10
      db 'entering the name of this program followed by the command',13,10
      db 'that you would like to execute.',13,10
      db 'This program was created by the TXT2PAS conversion utility',13,10
 db 'Copyright 1988 by Keith P. Graham',13,10
 db 'This file cannot be distributed for SALE without',13,10
 db 'express written permission from Keith P. Graham',13,10
 db '238 Germonds Road, W. Nyack, NY 10994, (914) 623-4161',13,10
 db '$'
endif
vbuff   dw  0b000h
vport   dw  3bah
vloc    dw  0
autoscroll db 0
autoquit   db 0
echo_off   db 0
autofunc   db 0
autofind   db 0
panel      db 0  ; panel set switch
fast       db 0  ; use bios or not
set_wind  proc near
; this sets the window information
;
      ret
set_wind  endp
lod_byte proc near
if  exe
    cmp  si,0
    jg   do_lod_byte
; put segment control information here
do_lod_byte:
endif
    lodsb
      ret
lod_byte endp
main      proc     near
; this is the main entry point
; first thing to do is get the current status
      mov   ah,15
      int   10h
; al returns the vid status
      cmp   al,7
      je    good_status
      mov   vbuff,0b800h
      mov   vport,3dah
      cmp   al,2
      je    good_status
      cmp   al,3
      je    good_status
if com
      print err0
      int   20h
else
      mov   ah,14
      mov   al,7
      int   10h
      int   10h
      int   10h
      int   10h
      ret
endif
good_status:
      mov      currline,0
main_ret0:
      cmp     text,"~"
      jne     main_ret
      lea     si,text+1
      call    do_hex
main_ret:
      call     clear
      call     gdisplay
main2:
      call     trail
main3:
      cmp   autoquit,0
      je    by_qmain
      jmp   escx
; test of autofunc ~#1
by_qmain:
      cmp   autofunc,0
      je    main3a
      mov   al,autofunc
      mov   autofunc,0
      mov   autoscroll,0
      jmp   do_function
main3a:
      cmp   autofind,0
      je    main3b
      mov   autofind,0
      mov   autoscroll,0
      jmp   enter_do_find
; this is test strings
main3b:
      cmp      autoscroll,0
      je       main4
      cmp      autoscroll,1
      jne      autoback
      jmp      do_ascroll
autoback:
      cmp      autoscroll,-1
      jne      check_for_home
      jmp      do_uscroll
check_for_home:
      cmp      autoscroll,-2
      jne      main4
      mov      autoscroll,0
      jmp      home
main4:
      call     getkey
      cmp      bx,18  ; go_up
      je       no_fix_echo
      mov     echo_off,0
no_fix_echo:
      cmp      panel,0
      je       go_to_jump
      cmp      bx,0
      je       go_to_jump
      cmp      bx,10
      je       go_to_jump
      jmp      main4
go_to_jump:
      jmp      goline[bx]
do_line:
      cmp     autoquit,0
      je      by_aquit
do_line_exit:
      ret
; test quit
by_aquit:
; gdisplay the line pointed to by si at the active line
;
      mov     cx,80
      mov     dx,actline
      xchg    dl,dh
      mov     dl,0
dl_loop:
      push    cx
      push    dx
      mov     ah,2  ; sets the cursor position
      mov     bx,0
      int10h
get_char:
      call    lod_byte
      cmp     al,13
      je      exit_dl
      cmp     al,10
      je      exit_dl
      cmp     al,'~'     ;tilde
      jne     no_tilde
      cmp     byte ptr ds:[si],'~'
      je      by_tilde
      cmp     byte ptr ds:[si],'{'
      je      got_wind
      cmp     byte ptr ds:[si],'/'
      je      got_slash
      cmp     byte ptr ds:[si],'#'
      je      got_func
      cmp     byte ptr ds:[si],'0'
      jl      no_tilde
      cmp     byte ptr ds:[si],'f'
      jg      no_tilde
      cmp     byte ptr ds:[si],'9'
      jle     do_tilde_stuff
      cmp     byte ptr ds:[si],'A'
      jl      no_tilde
      cmp     byte ptr ds:[si],'F'
      jle     do_tilde_stuff
      cmp     byte ptr ds:[si],'a'
      jl      no_tilde
do_tilde_stuff:
      call    do_hex
      jmp     get_char
got_slash:
; here we use the text to do a key stroke for us
      jmp     do_tkey
got_func:
      inc  si
      inc  si
      jmp   get_char
got_wind:
      call  set_wind
      jmp     get_char
by_tilde:
      call lod_byte
no_tilde:
      mov     ah,09     ; puts a character and attribute to screen
      mov     cx,1
      mov     bh,0
      mov     bl,attrib
      cmp     echo_off,0
      jne     by_int
      int10h
by_int:
      pop     dx
      pop     cx
      inc     dl
      loop    dl_loopx
      ret
dl_loopx:
      jmp    dl_loop
exit_dl:
      pop     dx
      pop     cx
      ret
do_function:
; function key has been pressed
; have to scan the file until we find the function key tilde # sequence
;    hey lets put one here ~#1 this is function 1
;
      mov    dl,al
      mov      bx,currline    ; current line number
      mov      bp,bx
; get first line going
      shl      bx,1       ; div by 2
      mov      di,textab      ; location of text table
      mov      si,word ptr[bx+di]  ; si has the current line number
      add      si,currtab
      inc      si
      call     find_func
      jc       not_func1
; have the guy
found_func:
      sub      si,word ptr[bx+di]
      sub      si,3
      mov      currtab,si
      shr      bx,1
      mov      currline,bx
      jmp  main_ret
not_func1:
; not on the first line
      shr  bx,1
      inc  bx
      cmp  bx,texlen
      jg   search_top
      shl      bx,1       ; div by 2
      mov      di,textab      ; location of text table
      mov      si,word ptr[bx+di]  ; si has the current line number
      call     find_func
      jc       not_func1
      jmp      found_func
search_top:
; here we reset the bx to start from top
      mov  bx,0
not_func2:
      shr  bx,1
      inc  bx
      cmp  bx,bp
      jg     not_func3
      shl      bx,1       ; div by 2
      mov      di,textab      ; location of text table
      mov      si,word ptr[bx+di]  ; si has the current line number
      call     find_func
      jc       not_func2
      jmp      found_func
not_func3:
      jmp  main_ret
find_func:
      call  lod_byte
      cmp   al,13
      jne   check_nextf
not_found:
      stc
      ret
check_nextf:
      cmp   al,'~'
      jne   find_func
      call  lod_byte
      cmp   al,'~'
      je   find_func
      cmp   al,13
      je    not_found
      cmp   al,'#'
      jne   check_nextf
      call  lod_byte
      cmp   al,13
      je    not_found
      cmp   al,dl
      jne   check_nextf
      clc
      ret
aup: call go_up
       jmp   main_ret
adown:
     call  go_down
       jmp   main_ret
ahome: jmp home
do_tkey:
; this routine has a guy in the next key to do a simulated keystroke
; keys are S for scroll, U
      call lod_byte
      call lod_byte
      cmp  al,'U'
      je   aup
      cmp  al,'D'
      je   adown
      cmp  al,'T'
      je   ahome
      cmp  al,'S'
      je   tscroll
      cmp  al,'B'
      je   bscroll
      cmp  al,'Q'
      je   qscroll
      cmp  al,'O'
      je   oscroll
      cmp  al,'N'
      je   nscroll
      cmp  al,'W'
      je   wscroll
    if com
        cmp  al,'X'
        je   execute_prog
    endif
      cmp  al,'H'
      je   change_head
      cmp  al,'F'
      je   change_foot
      cmp  al,'P'
      je   set_panel
      cmp  al,'R'
      je   reset_panel
      cmp  al,'0'
      jl   by_tf
      cmp  al,'9'
      jg   by_tf
; got a function key
      mov  autofunc,al
      jmp     get_char
by_tf:
      cmp   al,'Z'
      je    hscroll
      cmp   al,'{'
      je    afind
      jmp     get_char
tscroll:
; starts the scroll
      mov     autoscroll,1
      jmp     get_char
bscroll:
      mov     autoscroll,-1
      jmp     get_char
qscroll:
      mov     autoquit,-1
      jmp     get_char
oscroll:
      mov     echo_off,-1
      jmp     get_char
nscroll:
      mov     echo_off,0
      jmp     get_char
wscroll: ;waits for key
; first clear the key buff
      mov     ah,1
      int    16h
      jz     wait_key
      mov    ah,0
      int    16h
      jmp     wscroll
wait_key:
       mov   ah,0
       int   16h
       cmp    al,27
       jne    by_e
      jmp    escx
by_e:
       jmp     get_char
hscroll:
      mov     autoscroll,-2
      jmp     get_char
change_head:
     jmp  change_texth
change_foot:
     jmp  change_textf
if com
execute_prog:
     jmp   execute_it
endif
reset_panel:
      mov  panel,0
      jmp     get_char
set_panel:
      mov  panel,1
      jmp     get_char
afind:
      cld
      lea  di,search
      mov  cx,63
      mov  searchp,cl
afindl:
      push  cx
      call lod_byte
      pop  cx
      cmp  al,'}'
      je  end_afind
      cmp  al,13
      je  end_afind
      stosb
      loop  afindl
end_afind:
; have the string in searchp
       mov   ax,0
       stosw
       inc   currline
       jmp   enter_do_find
do_number:
; this finds a character in the file by searching forward
; prompt for character
      mov     dx,1800h
      mov     ah,2
      mov     bx,0
      int     10h
;
      lea  si,numb_please
nmloop:
      call lod_byte
      cmp  al,0
      je   e_nmloop
      mov  ah,14
      mov  cx,0
      int  10h
      jmp  nmloop
e_nmloop:
      mov     dx,1813h
      mov     ah,2
      mov     bx,0
      int     10h
; this is where the search function goes
      lea  si,numbp
      call getline
; the stuff above will have to be replaced with a bios equivalent
      cmp  al,13
      je    exit_do_numb
      jmp  exit_do_numd
exit_do_numb:
      cmp  numb,0
      jne  exit_do_numc
exit_do_numd:
      jmp  exit_do_num
exit_do_numc:
; here we have a number
; must convert it to upper a number
       mov   bx,0
       mov   dx,0
       lea   si,numb
       call  lod_byte
       cmp   al,' '
       je    get_n2
       cmp   al,'0'
       jl    exit_do_numd
       cmp   al,'9'
       jg    exit_do_numd
       and   al,0fh
       mov   bl,al
       jmp   get_n2a
get_n2:
       lodsb
       cmp   al,' '
       je    get_n3
       cmp   al,0
       je    exit_do_numd
       jmp   by_n2
get_n2a:
       lodsb
       cmp   al,' '
       je    convert_num
       cmp   al,0
       je    convert_num
by_n2:
       cmp   al,'0'
       jl    exit_do_numd
       cmp   al,'9'
       jg    exit_do_numd
       and   al,0fh
       mov   bh,bl
       mov   bl,al
       jmp   get_n3a
; third spot
get_n3:
       lodsb
       cmp   al,' '
       je    get_n4
       cmp   al,0
       je    exit_do_num
       jmp   by_n3
get_n3a:
       lodsb
       cmp   al,' '
       je    convert_num
       cmp   al,0
       je    convert_num
by_n3:
       cmp   al,'0'
       jl    exit_do_num
       cmp   al,'9'
       jg    exit_do_num
       and   al,0fh
       mov   dl,bh
       mov   bh,bl
       mov   bl,al
       jmp   get_n4a
; third spot
get_n4:
       lodsb
       cmp   al,' '
       je    exit_do_num
       cmp   al,0
       je    exit_do_num
       jmp   by_n4
get_n4a:
       lodsb
       cmp   al,' '
       je    convert_num
       cmp   al,0
       je    convert_num
by_n4:
       cmp   al,'0'
       jl    exit_do_num
       cmp   al,'9'
       jg    exit_do_num
       and   al,0fh
       mov   dh,dl
       mov   dl,bh
       mov   bh,bl
       mov   bl,al
convert_num:
; here the conversion
       mov   ah,0
       mov   al,bl
       mov   bp,ax
       mov   al,bh
       mov   cl,10
       mul   cl
       add   bp,ax
       mov   al,dl
       mov   ah,0
       mov   cl,100
       mul   cl
       add   bp,ax
       mov   al,dh
       mov   ah,0
       mov   cx,1000
       mul   cx
       add   bp,ax
       cmp   bp,texlen
       jg    exit_do_num
       cmp   bp,0
       jl    exit_do_num
       cmp   bp,0
       je    go_curr_0
       dec   bp
go_curr_0:
       mov   currline,bp
exit_do_num:
       jmp   main_ret
if com
execute_it:
; set upt the command_line for execute
       call  do_exec
      jmp      home
endif
change_textf:
; this changes the headers or footers, di points to head or foot
; have to center the heading
     lea  di,trailer
     cld
     mov  cx,63
     mov  al,32
    rep  stosb
     mov   bx,0
     lea  di,trailer
     call    lod_byte
     cmp  al,'{'
     je   get_ft
     mov   al,' '
      jmp     get_char
get_ft:
     push  bx
     call  lod_byte
     pop   bx
     cmp   al,'}'
     je    done_ft
     cmp   al,13
     je    done_ft
     cld
     inc   bx
     stosb
     jmp   get_ft
done_ft:
      mov    cx,bx
      call   put_trailer
      mov    al,' '
      jmp     get_char
change_texth:
; this changes the headers or footers, di points to head or foot
; have to center the heading
     lea  di,heading
     cld
     mov  cx,81
     mov  al,32
    rep  stosb
     mov   bx,0
     lea  di,heading
     call    lod_byte
     cmp  al,'{'
     je   get_ht
     mov   al,' '
      jmp     get_char
get_ht:
     push  bx
     call  lod_byte
     pop   bx
     cmp   al,'}'
     je    done_ht
     cmp   al,13
     je    done_ht
     cld
     inc   bx
     stosb
     jmp   get_ht
done_ht:
      mov    cx,bx
      call   put_heading
      mov    al,' '
      jmp     get_char
do_find:
; this finds a character in the file by searching forward
; prompt for character
      mov     dx,1800h
      mov     ah,2
      mov     bx,0
      int     10h
;
      lea  si,match
prloop:
      lodsb
      cmp  al,0
      je   e_prloop
      mov  ah,14
      mov  cx,0
      int  10h
      jmp  prloop
e_prloop:
      mov     dx,180fh
      mov     ah,2
      mov     bx,0
      int     10h
; this is where the search function goes
      lea  si,searchp
      call getline
; the stuff above will have to be replaced with a bios equivalent
      cmp  al,13
      je    exit_do_findb
      jmp  exit_do_find
exit_do_findb:
      cmp  search,0
      jne  exit_do_findc
exit_do_findd:
      jmp  exit_do_find
exit_do_findc:
; have to find out how long it is
enter_do_find:  ; for autostuff
      lea  di,search
      mov  cl,searchp
      mov  ch,0
      mov  si,di
      mov  al,0
      cld
repne   scasb
      jne  exit_do_findd
      sub  di,si
      mov  cx,di
      dec  cx
      mov  searchpl,cx
; got a string to search for
; convert it to upper case
      lea  si,search
s_upper:
      cmp  byte ptr ds:[si],'a'
      jl  re_s_loop
      cmp  byte ptr ds:[si],'z'
      jg  re_s_loop
      sub  byte ptr ds:[si],32
re_s_loop:
      inc  si
      loop s_upper
; got the guy in upper case, have to search each line
; starting with the next line down
;
;
      mov      al,search
      mov      dl,al  ; al has the byte we are looking for
      mov      bx,currline    ; current line number
      mov      bp,bx
; get first line going
      shl      bx,1       ; div by 2
      mov      di,textab      ; location of text table
      mov      si,word ptr[bx+di]  ; si has the current line number
      add      si,currtab
      inc      si
      jmp  by_cont
do_cont:
      mov      al,search
      mov      dl,al  ; al has the byte we are looking for
      mov      bx,currline    ; current line number
      inc      bx
      mov      bp,bx
; get first line going
      shl      bx,1       ; div by 2
      mov      di,textab      ; location of text table
      mov      si,word ptr[bx+di]  ; si has the current line number
by_cont:
      push     di
      call     find_seek
      pop      di
      jc       not_seek1
; have the guy
found_seek:
      mov      currtab,0
      shr      bx,1
      mov      currline,bx
      jmp  main_ret
not_seek1:
; not on the first line
      shr  bx,1
      inc  bx
      cmp  bx,texlen
      jg   search_tops
      shl      bx,1       ; div by 2
      mov      di,textab      ; location of text table
      mov      si,word ptr[bx+di]  ; si has the current line number
      push     di
      call     find_seek
      pop      di
      jc       not_seek1
      jmp      found_seek
search_tops:
; here we reset the bx to start from top
      mov  bx,0
not_seek2:
      shr  bx,1
      inc  bx
      cmp  bx,bp
      jg     not_seek3
      shl      bx,1       ; div by 2
      mov      di,textab      ; location of text table
      mov      si,word ptr[bx+di]  ; si has the current line number
      push     di
      call     find_seek
      pop      di
      jc       not_seek2
      jmp      found_seek
not_seek3:
      jmp  main_ret
;
;
exit_do_find:
       jmp   main_ret
find_seek:
      call  lod_byte
      cmp   al,13
      jne   check_nexts
not_founds:
      stc
      ret
not_foundsx:
      pop  si
      stc
      ret
check_nextsa:
      mov   dl,search
      pop   si
      jmp   find_seek
check_nexts:
; convert to uppsr
      cmp      al,'a'
      jl       up_1
      cmp      al,'z'
      jg       up_1
      sub      al,32
up_1:
      cmp   al,dl
      jne   find_seek
      mov   cx,searchpl
      dec   cx
      lea   di,search
      push  si
      cmp   cx,0
      jg    searchl
      pop   si
      clc
      ret
searchl:
      call  lod_byte
      cmp   al,13
      je    not_foundsx
      cmp   al,'a'
      jl    ok_uppers
      cmp   al,'z'
      jg    ok_uppers
      sub   al,32
ok_uppers:
      inc   di
      cmp   al,byte ptr ds:[di]
      jne   check_nextsa
      loop  searchl
      pop   si
      clc
      ret
left:
; if the left key is pressed we are moving right
       sub   currtab,20
       cmp   currtab,0
       jge   oktab
       mov   currtab,0
       jmp   oktab
oktab:
       jmp   main_ret
oktab2:
       jmp   main_ret0
right:
       add   currtab,20
       cmp   currtab,1020
       jl    oktab
       mov   currtab,1020
       jmp   oktab
home:
       mov   currtab,0
       mov   currline,0
       jmp   oktab2
endk:
       mov   currtab,0
       mov   ax,texlen
       sub   ax,24
       mov   currline,ax
       call  check_line
       jmp   main_ret
escx:
; the last line must be cleared
      mov      ah,7
      mov      al,0
      mov      cx,1800h
      mov      dx,184fh
      mov      bh,07h
      int      10h
; locate on line 23
      mov     dx,1700h; 24th line
      mov     ah,2
      mov     bx,0
      int10h
if com
    mov  ax,4c00h
    int  21h
endif
       ret
pgdn:
       add   currline,23
       call  check_line
       jmp   main_ret
pgup:
       cmp   currline,0
       je    no_pgup
       sub   currline,23
       call  check_line
       jmp   main_ret
up:
       cmp   currline,0
       jne   ok_up1
no_pgup:
       jmp   main3
ok_up1:
       call  go_up
       jmp   main2
go_up:
       sub   currline,1
       call  scrolldn
       mov   bx,currline
      shl      bx,1
      mov      di,textab
      mov      si,word ptr[bx+di]
      mov      actline,1
      call    do_line
       ret
scroll_dir   db 0
speed_scroll:
       mov  ah,0
       int  16h
       cmp  bp,0ffffh
       je   do_ascroll2
       xor  bp,0ffffh
       inc  bp
       shr  bp,1
       dec  bp
       xor  bp,0ffffh
       jmp  do_ascroll2
slow_scroll:
       mov  ah,0
       int  16h
       cmp  bp,0ff00h
       je   do_ascroll2
       xor  bp,0ffffh
       inc  bp
       shl  bp,1
       dec  bp
       xor  bp,0ffffh
       jmp  do_ascroll2
do_uscroll:
       mov   bp,1111111111111000b
       mov   scroll_dir,1
       jmp   do_ascroll2
do_ascroll:
       mov   bp,1111111111111000b
       mov   scroll_dir,0
do_ascroll2:
; automatically scrolls until a key is pressed (for now)
       mov   ah,1
       int   16h
       jz    no_skey
       cmp   ah,52h
       je    speed_scroll
       cmp   ah,53h
       je    slow_scroll
       cmp   al,20h
       jne   leave_ascroll2
       mov   ah,0
       int   16h
ascroll_wait:
       mov   ah,1
       int   16h
       jz    ascroll_wait
       cmp   al,20h
       jne   leave_ascroll2
       mov   ah,0
       int   16h
       jmp   no_skey
leave_ascroll2:
       mov   autoscroll,0
leave_ascroll:
       jmp   main2
no_skey:
; get the time
       mov   ah,0  ; get time
       int   1ah
       mov   di,dx
       mov   si,cx
       and   di,bp
not_yet_time:
       mov   ah,0  ; get time
       int   1ah
       cmp   cx,si
       jne   its_time
       and   dx,bp  ; half second?
       cmp   dx,di
       je    not_yet_time
its_time:
       cmp   scroll_dir,0
       jne   go_backwards
       push  bp
       call  go_down
       pop   bp
       cmp   autoscroll,0
       je    ascroll_ret
       cmp   autoscroll,1
       je    ascroll_ret
       jmp   leave_ascroll
ascroll_ret:
       jmp   do_ascroll2
go_backwards:
       cmp   currline,0
       jne   do_backscroll
       jmp   main3
do_backscroll:
       push  bp
       call  go_up
       pop   bp
       cmp   autoscroll,0
       je    ascroll_ret
       cmp   autoscroll,-1
       je    ascroll_ret
       jmp   leave_ascroll
       jmp   do_ascroll2
down:
     call  go_down
       jmp   main2
go_down:
      mov    ax,texlen
      cmp    ax,23
      jg     ok_down1
      ret
ok_down1:
      sub    ax,24
      cmp    currline,ax
      jl     ok_down2
      ret
ok_down2:
       add   currline,1
       call  scrollup
       mov   bx,currline
       add   bx,22
      shl      bx,1
      mov      di,textab
      mov      si,word ptr[bx+di]
      mov      actline,23
      call    do_line
      ret
goline    dw  do_function,left,right,home,endk,escx,pgup,pgdn,down,up,twrite
      dw  do_find,do_cont,do_number,do_ascroll,do_uscroll
twrite:
if com
; this writes the file out to a text file
      call  clear
; locate on line 2
      mov     dx,200h; second line
      mov     ah,2
      mov     bx,0
      int     10h
      print   fprompt
      lea     si,fname
      call    getline
      cmp     al,13
      je      okfname
       jmp   main_ret
okfname:
      lea     dx,fname+1
       mov   ax,3c00h
       mov   cx,0
       int   21h
       jnc   good_open3
; try open as output if it is a device
      lea     dx,fname+1
       clc
       mov   ax,3d02h
       int   21h
       jnc   good_open3
       jmp   main_ret
good_open3:
       mov   bx,ax
       mov   ah,40h
       mov   cx,filesize2
       lea   dx,text
       int   21h
      mov    ah,3eh
      int    21h
endif
      jmp  main_ret
check_line:
; checks to see that we are within range on lines
      cmp    currline,0
      jge    not_neg
      mov    currline,0
      ret
not_neg:
      mov    ax,texlen
      cmp    ax,23
      jle    samepage
      sub    ax,24
      cmp    currline,ax
      jle    not_big
      mov   currline,ax
      ret
not_big:
      ret
samepage:
      mov    currline,0
      ret
gdisplay:
; gdisplays whole buffer to screen
      mov      cx,23
      mov      bx,currline
      mov      actline,1
disploop:
      push     cx
      inc      bx
      cmp      texlen,bx
      jg       more_text
      pop      cx
      ret
more_text:
      dec      bx
      push     bx
      shl      bx,1
      mov      di,textab
      mov      si,word ptr[bx+di]
; check to see if we have to tab over
      cmp      currtab,0
      je       notab
; have to tab to right with si
      mov     cx,currtab
tabloop:
      call    lod_byte
      cmp     al,13
      je      end_disp
      cmp     al,10
      je      end_disp
      loop    tabloop
notab:
; here gdisplay the line
; si has the line offset
      call    do_line
end_disp:
      pop      bx
      inc      bx
      pop      cx
      inc      actline
      loop     disploop
      ret
getkey:
      mov     ah,0
      int     16h
      cmp     al,'S'
      je      got_an_s
      cmp     al,'s'
      je      got_an_s
      mov     al,ah
      lea     di,keytab
      mov     cx,15
      cld
repne     scasb
      jne     check_func
      sub     cx,15
      neg     cx
      mov     bx,cx
      shl     bx,1
; bx returns with a word offset for use in jmps
      ret
got_an_s:
; this toggles the fast screen function
     xor  fast,1
     jmp   getkey
check_func:
      cmp     al,3bh
      jl     getkey
      cmp     al,44h
      jg     getkey
; have a function key
      mov    bx,0
      sub    al,10
      cmp    al,3ah
      je     fix_f10
      ret
fix_f10:
      sub   al,10
      ret
clear:
; clears the screen
      mov      ah,7
      mov      al,0
      mov      cx,100h
      mov      dx,174fh
      mov      bh,attrib
      int      10h
      call     put_heading
      mov      al,' '
      ret
put_heading:
; locate and put heading
      push  ax
      push  bx
      push  cx
      push  dx
      push  si
      push  di
      push  bp
      mov     dx,0  ; top line
      mov     ah,2
      mov     bx,0
      int10h
      lea     si,heading
      mov     cx,80
      mov     bp,1
headingloop:
      push    cx
      lodsb
      mov     ah,9
      mov     cx,1
      mov     bh,0
      mov     bl,0fh
      int10h
      mov     dx,bp
      mov     ah,2
      mov     bx,0
      int10h
      inc     bp
      pop     cx
      loop    headingloop
      pop  bp
      pop  di
      pop  si
      pop  dx
      pop  cx
      pop  bx
      pop  ax
;
      ret
trail:
; calculate the line number
       mov      cx,10
       mov      ax,currline
       inc      ax
       mov      dx,0
       div      cx
       or       dl,30h
       mov      dline+3,dl
       mov      dx,0
       div      cx
       or       dl,30h
       mov      dline+2,dl
       mov      dx,0
       div      cx
       or       dl,30h
       mov      dline+1,dl
       mov      dx,0
       div      cx
       or       dl,30h
       mov      dline+0,dl
       mov      dx,0
; calculate the tab number
       mov      cx,10
       mov      ax,currtab
       inc      ax
       mov      dx,0
       div      cx
       or       dl,30h
       mov      dcol+2,dl
       mov      dx,0
       div      cx
       or       dl,30h
       mov      dcol+1,dl
       mov      dx,0
       div      cx
       or       dl,30h
       mov      dcol+0,dl
       mov      dx,0
; locate and put trailer
      call   put_trailer
      ret
put_trailer:
      push  ax
      push  bx
      push  cx
      push  dx
      push  si
      push  di
      push  bp
      lea     si,trailer
      mov     bp,1700h
      mov     dx,bp
      mov     ah,2
      mov     bx,0
      int     10h   ; real cursor locate
      mov     bp,1800h
      mov     cx,80
trailerloop:
      push    cx
      mov     dx,bp
      mov     ah,2
      mov     bx,0
      int10h
      lodsb
      mov     ah,9
      mov     cx,1
      mov     bh,0
      mov     bl,0fh
      int10h
      inc     bp
      pop     cx
      loop    trailerloop
      pop  bp
      pop  di
      pop  si
      pop  dx
      pop  cx
      pop  bx
      pop  ax
;
      ret
do_int10h:
; this is done only if we are going fast
    cmp  ah,2
    je   do_loc10
    cmp  ah,9
    je   do_10func9
    int   10h
    ret
do_10func9:
; here we put someone in the position
; character is in al, attrib in bl
    push  ax
    push  cx
    push  dx
    push  di
    push  es
    mov   di,vloc
    mov   ch,bl
    mov   cl,al
    mov   es,vbuff
    mov   dx,vport
c_wait1:
    in    al,dx
    test  al,1
    jnz   c_wait1
    cli
c_wait2:
    in    al,dx
    test  al,1
    jz   c_wait2
    mov   word ptr es:[di],cx
;_wait3:
;   in    al,dx
;   test  al,1
;   jnz   c_wait3
;   cli
;_wait4:
;   in    al,dx
;   test  al,1
;   jnz   c_wait4
;   mov   byte ptr es:[di+1],ch
    sti
    pop   es
    pop   di
    pop   dx
    pop   cx
    pop   ax
    ret
do_loc10:
    push  ax
    push  cx
    push  dx
; dh:dl has the,row column
    mov   al,dh
    mov   cl,80
    mul   cl
    mov   dh,0
    add   ax,dx
    shl   ax,1
    mov   vloc,ax
    pop   dx
    pop   cx
    pop   ax
    ret
scrollup:
; scrolls up one line
      mov      ah,6
      mov      al,1
      mov      cx,100h
      mov      dx,174fh
      mov      bh,attrib
      int      10h
      ret
scrolldn:
; scrolls down one line
      mov      ah,7
      mov      al,1
      mov      cx,100h
      mov      dx,174fh
      mov      bh,attrib
      int      10h
      ret
do_hex:
; si points to two hex digits which are returned in al
      cmp      byte ptr ds:[si],'0'
      jl       hex_ret
      cmp      byte ptr ds:[si],'f'
      jg       hex_ret
      cmp      byte ptr ds:[si],'9'
      jle      dig1_pass
      cmp      byte ptr ds:[si],'A'
      jl       hex_ret
      cmp      byte ptr ds:[si],'F'
      jle      dig1_pass
      cmp      byte ptr ds:[si],'a'
      jl       hex_ret
dig1_pass:
      cmp      byte ptr ds:[si+1],'0'
      jl       hex_ret
      cmp      byte ptr ds:[si+1],'f'
      jg       hex_ret
      cmp      byte ptr ds:[si+1],'9'
      jle      dig2_pass
      cmp      byte ptr ds:[si+1],'A'
      jl       hex_ret
      cmp      byte ptr ds:[si+1],'F'
      jle      dig2_pass
      cmp      byte ptr ds:[si+1],'a'
      jl       hex_ret
dig2_pass:
      call    lod_byte
      cmp     al,'9'
      jle     no_char1
      sub     al,7
no_char1:
      and     al,0fh
      mov     cl,16
      mul     cl
      mov     bl,al
      call    lod_byte
      cmp     al,'9'
      jle     no_char2
      sub     al,7
no_char2:
      and     al,0fh
      add     bl,al
      mov     attrib,bl
hex_ret:
      ret
main      endp
insert db 0
getline  proc  near
; on entry to getline the cursor is in the correct position and
; si points to a line of the form length,data
      push   bx
      push   cx
      push   dx
      push   si
      push   di
      push   bp
;
; get the current cursor position and put it in bp
      mov    ah,3
      mov    bx,0
      int    10h
      mov    bp,dx
      call   gdisplay_l
; from here on out, bx is the character index
      mov    bx,0
; this is the loop to get characters and add them to the string
getc_loop:
      mov    ah,0
      int    16h
      cmp    al,27
      je     got_esc
      cmp    al,13
      je     got_13
      cmp    ah,53h
      je     got_delete
      cmp    ah,4bh
      je     got_left
      cmp    ah,4dh
      je     got_right
      cmp    ah,52h
      je     got_insert
      cmp    ah,47h
      je     got_clean
      cmp    ah,4fh
      je     got_clean
; check for the cursor controls
      cmp    al,8
      je     got_8
      cmp    bl,byte ptr ds:[si]
      jge    getc_loop
      cmp    al,1bh
      jle    getc_loop
; gdisplay the current character on the screen
;
; check to see if insert is needed
      cmp    insert,1
      jne    no_insert
      call   do_insert
no_insert:
      push   bx
      mov    byte ptr ds:[si+bx+1],al
      mov    ah,9
      mov    cx,1
      mov    bl,070h
      int    10h
go_right:
      inc    bp
      mov    bx,0
      mov    dx,bp
      mov    ah,2
      int    10h
      pop    bx
      inc    bx
ret_to_gc:
      jmp    getc_loop
got_delete:
     jmp   got_delete1
got_esc:
; escape cleans the line
     call  clean_line
got_0:
got_13:
     jmp   exit_line
got_left:
      cmp   bx,0
      jle   ret_to_gc
; check to see if the current position is a zero and we are
; moving into a space
      cmp    byte ptr ds:[si+bx+1],0
      jne    by_nopad
      cmp    byte ptr ds:[si+bx],' '
      jne    by_nopad
      mov    byte ptr ds:[si+bx],0
by_nopad:
      dec    bp
      push   bx
      mov    bx,0
      mov    dx,bp
      mov    ah,2
      int    10h
      pop    bx
      dec    bx
      jmp    getc_loop
got_insert:
      xor   insert,1
getc_loope:
      jmp    getc_loop
got_right:
      cmp   byte ptr ds:[si],bl
      jl    ret_to_gc
      push  bx
; check to see if going right gives us a 0
      cmp   byte ptr ds:[si+bx+1],0
      jne   no_pad
      mov   byte ptr ds:[si+bx+1],' '
no_pad:
      jmp   go_right
got_clean:
      call  clean_line
      call  gdisplay_l
      jmp    getc_loop
got_8:
; backspace
      cmp   bx,0
      je    getc_loope
      dec    bp
      push   bx
      mov    dx,bp
      mov    bx,0
      mov    ah,2
      int    10h
      pop    bx
      dec    bx
got_delete1:
      jmp   do_backsp
exit_line:
; this accepts the current end of line
;
      pop    bp
      pop    di
      pop    si
      pop    dx
      pop    cx
      pop    bx
; last key pressed in al
      ret
do_insert:
; inserts into the curretn line
; nearly the same as delete
      push  ax
      push  si
      push  di
      mov   cl,byte ptr ds:[si]
      mov   ch,0
      dec   cx
      add   si,cx
      sub   cx,bx
      mov   di,si
      inc   di
      cmp   cx,0
      je    by_bs2
      std
rep   movsb
by_bs2:
      cld
      pop   di
      pop   si
      push   bx
      push   dx
      mov    dx,bp
      sub    dx,bx
      mov    bx,0
      mov    ah,2
      int    10h
      pop    dx
      pop    bx
      call  gdisplay_l
      push   bx
      push   dx
      mov    dx,bp
      mov    bx,0
      mov    ah,2
      int    10h
      pop    dx
      pop    bx
      pop   ax
      ret
do_backsp:
      push  si
      push  di
      mov   cl,byte ptr ds:[si]
      mov   ch,0
      inc   si
      add   si,bx
      mov   di,si
      inc   si
      sub   cx,bx
      cmp   cx,0
      je    by_bs
      cld
rep   movsb
by_bs:
      pop   di
      pop   si
      push   bx
      push   dx
      mov    dx,bp
      sub    dx,bx
      mov    bx,0
      mov    ah,2
      int    10h
      pop    dx
      pop    bx
      call  gdisplay_l
      push   bx
      push   dx
      mov    dx,bp
      mov    bx,0
      mov    ah,2
      int    10h
      pop    dx
      pop    bx
      jmp   getc_loop
gdisplay_l:
; gdisplays current line again
      push   bx
      push   bp
      mov    ah,3
      mov    bx,0
      int    10h
      mov    bp,dx
; now clear out the line with reverse video
      mov    cl,byte ptr ds:[si]
      mov    ch,0
      push   cx
      mov    ah,9
      mov    al,20h
      mov    bl,070h
      int    10h
; now print out each of the guys on the line
      pop    cx
      push   si
      inc    si
      push   bp
gl_loop1:
; locate the cursor
      push   cx
      mov    bx,0
      mov    dx,bp
      mov    ah,2
      int    10h
      cld
      lodsb
      cmp    al,0
      je     end_gll1
      cmp    al,13
      je     end_gll1
      mov    ah,9
      mov    cx,1
      mov    bl,70h
      int    10h
      inc    bp
      pop    cx
      loop   gl_loop1
      push   cx
end_gll1:
      pop    cx
      pop    bp
      pop    si
      mov    bx,0
      mov    dx,bp
      mov    ah,2
      int    10h
      pop    bp
      pop    bx
      ret
clean_line:
; clears out the line
; si still ahs the line in it
      push  ax
      push  cx
      push  di
      mov   cl,byte ptr ds:[si]
      mov   ch,0
      mov   di,si
      inc   di
      mov   al,0
      cld
rep   stosb
      pop   di
      pop   cx
      pop   ax
      ret
getline  endp
; data after code here
c10s    dw   0 ; cursor location at start of int 10
c10     dw   0 ; current cursor location
if com
fprompt   db  '  If you want to write to a file enter the file name.',13,10
      db  '  If you want to print the file enter LPT1 or LPT2',13,10
      db  10,'  ENTER: $'
fname     db  64,0,65 dup(0)
endif
attrib    db  07h
if com
trailer   db  'Esc=Quit,T=Write,F=Find,C=Cont,Keys=,,',26,',,PgUp,PgDn,Home,End,Row='
else
trailer   db  'Esc=Quit, F=Find, C=Cont, Keys=, , ',26,', , PgUp, PgDn,Home,End,Row='
endif
dline     db  '0000,Col='
dcol      db  '000                                        '
keytab    db  4bh,4dh,47h,4fh,01h,49h,51h,50h,48h,14h,21h,2eh,31h,1fh
      db  16h,0
heading   db  81 dup(0)
searchpl  dw  0
searchp   db  63
search    db  64 dup(0)
numb_please db 13,'Enter line number: ',60 dup(' '),0
numbp  db 4
numb   db 5 dup(0)
match     db  13,'Enter string:'
      db  66 dup(' '),0
currline  dw       0
currtab   dw       0
actline   dw       0
filesize2 dw  0
; text data goes here
texlen    dw   0
textab    dw   0
sistack    dw  512 dup(0)
savess   dw  0
savesp   dw  0
savespl  dw  0
savessl  dw  0
if  ncom
;
;   ALL PAST HERE IS RESIDENT STUFF
;
;
; data areas for resident stuff -
int9      dd  0
int9ip   equ word ptr int9
int9cs   equ word ptr int9 + 2
semaphore db  0
cursor   dw 0
cursmode dw 0
bhpage   db  0
screensave dw  2000 dup(0)
START2       PROC      NEAR
keyboard:
; we are entering here due to a key being struck
; first check the keyboard area to see if the CTRL and ALT are ppasssed
;
; first call the keyboard interrupt so that it can handle the
; keystroke
;
      pushf      ; fake the way an interrupt pushes flags
      cli
      call cs:int9
      sti
      push  ax
      mov  al,1
lock    xchg cs:semaphore,al
      test al,al
      jz   int9_shift
      pop  ax
      iret
int9_return:
      mov  cs:semaphore,0
      pop  ax
      iret
int9_shift:
; no one is using this guy so we will check out the shift state
; this uses two hot keys, one is Alt-Left Shift-T and the other
; is Alt-Ctrl-Equal.
;
      mov  ah,2   ; get shift status
      int  16h    ; get keyboard
; status returns in al
      and  al,0fh ; get rid of caps or num lock stuff
;
      cmp  al,cs:shift1 ; has the Alt and Left shift been pressed
      je   test_hot_1
      cmp  al,cs:shift2 ; has the Alt and Ctrl been pressed
      je   test_hot_2
      jmp  int9_return
test_hot_1:
; check to see if the next key to come in is B  scan 40h
      mov  ah,1
      int  16h
      jnz  check_key1
      jmp  int9_return
check_key1:
      cmp  ah,cs:scan1   ; Is the next character the "B" key?
      je   goforit
      jmp  int9_return
test_hot_2:
; check to see if the next key to come in is =  scan 83h
      mov  ah,1
      int  16h
      jnz  check_key2
      jmp  int9_return
check_key2:
      cmp  ah,cs:scan2  ; Is the next character the "=" key?
      je   goforit
      jmp  int9_return
goforit:
; save the world first switch to the local istack to save the
; actual istack.
; ax is the only thing in the local istack ( plus the interrupt ret)
      sti
      mov   cs:savessl,ss
      mov   cs:savespl,sp
      mov   ax,cs
      mov   ss,ax
      lea   sp,sistack+1022 ; double duty out of the local sistack
      push bx
      push cx
      push dx
      push si
      push di
      push bp
      push ds
      push es
; get the p so others won't be messed up
      mov  ah,0
      int  16h
      mov  ax,cs
      mov  ds,ax
      mov  es,ax
      call getcurs   ; gets the current cursor position
;
;
;   the program goes here
      call get_screen
      jc   exit_all
      call main
; keyboard entry here
      call rest_screen
;
;
;
exit_all:
      call retcurs   ; restores the old cursor position
      pop  es
      pop  ds
      pop  bp
      pop  di
      pop  si
      pop  dx
      pop  cx
      pop  bx
      mov  ss,cs:savessl
      mov  sp,cs:savespl
      pop  ax
      mov   cs:semaphore,0
      iret
get_screen:
; check the video type
      mov  ah,15
      int  10h
      cmp  al,2
      je   color
      cmp  al,3
      je   color
      cmp  al,7
      je   mono
      stc
      ret
mono:
       mov   ax,0b000h
       jmp   do_screen
color:
       mov   ax,0b800h
do_screen:
       cld
       mov   cx,2000
       mov   si,0
       lea   di,screensave
       push  ds
       mov   ds,ax
rep    movsw
       pop   ds
       ret
rest_screen:
; check the video type
      mov  ah,15
      int  10h
      cmp  al,2
      je   colorr
      cmp  al,3
      je   colorr
      cmp  al,7
      je   monor
      stc
      ret
monor:
       mov   ax,0b000h
       jmp   do_screenr
colorr:
       mov   ax,0b800h
do_screenr:
       cld
       mov   cx,2000
       mov   di,0
       lea   si,screensave
       push  es
       mov   es,ax
rep    movsw
       pop   es
       ret
START2       ENDP
getcurs   proc  near
; get video state
      mov ah,15
      int 10h
      mov bhpage,bh
      mov ah,3
      mov bh,bhpage
      int  10h
      mov  cursor,dx
      mov  cursmode,cx
      ret
getcurs   endp
retcurs   proc  near
      mov ah,2
      mov  dx,cursor
      mov bh,bhpage
      int  10h
      ret
retcurs   endp
endif
; this area is used by the resident and passthrough versions
;
;
; this data is used by the com and pas routines
;
if com
command_line db 129 dup(0)
; parmblock is used for the parmeters for the execute
parmblock  dw  0  ; this is the parmblock for execute
       dw command_line
tailds     dw  0
       dw 5ch ; fcb in psp
fcb1       dw  0
       dw 6ch ; fcb in psp
fcb2       dw  0
endif
;
;
if pas
command_line db 129 dup(0)
; parmblock is used for the parmeters for the execute
parmblock  dw  0  ; this is the parmblock for execute
       dw command_line
tailds     dw  0
       dw 5ch ; fcb in psp
fcb1       dw  0
       dw 6ch ; fcb in psp
fcb2       dw  0
endif
;
;
if   ncom
setpass  proc  near
endif
if  pas
;
; set up a local sistack
      lea  sp,sistack+1022
    cmp  byte ptr ds:[80h],1
    jg   ok_parmline
      print  err2
     int  20h
ok_parmline:
endif
if   ncom
;
; redirect interrupts here
;
      push  es
      mov   ax,3509h
      int   21h
      mov   int9cs,es
      mov   int9ip,bx
      pop   es
      mov   ah,25h
      mov   al,9h
      lea   dx,keyboard
      int   21h
endif
if  pas
      lea   dx,mess2
      mov   ah,9
      int   21h
   call  do_exec
return_pas:
;
; now reset the interrupts so we can leave
;
      push  ds
      lds   dx,int9
      mov   ah,25h
      mov   al,9h
      int   21h
      pop   ds
      int   20h
endif
if  com
do_exec:
      push  ax
      push  bx
      push  cx
      push  dx
      push  si
      push  di
      push  bp
; difference in pas and com is that the string is in command_line
; already
;
;  prepare for the exec function
; shrink memory
      mov   ax,texlen
      shl   ax,1
      add   ax,filesize2
      lea   bx,text
      add   bx,ax
   add   bx,15       ; trick to round up
   mov   cl,4
   shr   bx,cl       ; divide by 16 to get number of 16 byte blocks
   mov   ah,4ah      ; shrink
   int   21h
; create the commandline
;
; the command line has to start with /C and then the command
; and then end with a carriage return. It must have a byte at
; the front saying how long it is
   cld
   lea   di,command_line+1
   mov   al,'/'
   stosb
   mov   al,'C'
   stosb
   mov   al,' '
   stosb
; now copy the real command line in
   mov   cx,80h
   mov   bx,0
   cld
   call  lod_byte
   cmp   al,'{'
   je    got_x1
   ret
got_x1:
   call lod_byte
   cmp  al,'}'
   je   no_move
   cmp  al,13
   je   no_move
   inc   bx
   stosb
   loop  got_x1
no_move:
   mov   al,13
   inc   bx
   stosb
   mov   cx,bx
   add   cx,4
   mov   command_line,cl
; clear the screen
      mov      ah,7
      mov      al,0
      mov      cx,0000h
      mov      dx,184fh
      mov      bh,07h
      int      10h
; locate on line 0
      mov     dx,0; top line
      mov     ah,2
      mov     bx,0
      int10h
; set up the control block with segment information
   mov    tailds,ds
   mov    fcb1,ds
   mov    fcb2,ds
;
; find the comspec
;
   mov    es,word ptr  ds:[2ch]
   mov     di,0
   mov     cx,255
env_loop:
   cld
   mov   al,'='
repne   scasb
; if there is no comspec, there is something wrong with the system
   cmp   word ptr es:[di-3],'CE'
   jne   env_loop
   cmp   word ptr es:[di-5],'PS'
   jne   env_loop
   cmp   word ptr es:[di-7],'MO'
   jne   env_loop
   cmp   byte ptr es:[di-8],'C'
   jne   env_loop
; got the comspec
;
; save the sistack
;
   mov   savess,ss
   mov   savesp,sp
;
; set up the segment registers
;
; the comspec segment is in ES and should be in DS
;
   push  es
   pop   ds
   push  cs
   pop   es
   mov   dx,di
   lea   bx,parmblock
   mov   al,0
   mov   ah,4bh
; execute the thing
   int   21h
; here is where we return
   mov   ss,cs:savess
   mov   sp,cs:savesp
   mov   ax,cs
   mov   ds,ax
   mov   es,ax
      pop  bp
      pop  di
      pop  si
      pop  dx
      pop  cx
      pop  bx
      pop  ax
   print pause
   mov   ah,0
   int   16h
   ret
endif
if  pas
do_exec:
;
;  prepare for the exec function
; shrink memory
      mov   ax,texlen
      shl   ax,1
      add   ax,filesize2
      lea   bx,text
      add   bx,ax
   add   bx,15       ; trick to round up
   mov   cl,4
   shr   bx,cl       ; divide by 16 to get number of 16 byte blocks
   mov   ah,4ah      ; shrink
   int   21h
; create the commandline
;
; the command line has to start with /C and then the command
; and then end with a carriage return. It must have a byte at
; the front saying how long it is
   cld
   lea   di,command_line+1
   mov   al,'/'
   stosb
   mov   al,'C'
   stosb
   mov   al,' '
   stosb
; now copy the real command line in
   mov   si,81h
   mov   cl,byte ptr ds:[80h]
   mov   ch,0
   push  cx
   cmp   cx,0
   je    no_move
   cld
rep movsb
no_move:
   pop   cx
   add   cx,3
   mov   command_line,cl
; set up the control block with segment information
   mov    tailds,ds
   mov    fcb1,ds
   mov    fcb2,ds
;
; find the comspec
;
   mov    es,word ptr  ds:[2ch]
   mov     di,0
   mov     cx,255
env_loop:
   cld
   mov   al,'='
repne   scasb
; if there is no comspec, there is something wrong with the system
   cmp   word ptr es:[di-3],'CE'
   jne   env_loop
   cmp   word ptr es:[di-5],'PS'
   jne   env_loop
   cmp   word ptr es:[di-7],'MO'
   jne   env_loop
   cmp   byte ptr es:[di-8],'C'
   jne   env_loop
; got the comspec
;
; save the sistack
;
   mov   savess,ss
   mov   savesp,sp
;
; set up the segment registers
;
; the comspec segment is in ES and should be in DS
;
   push  es
   pop   ds
   push  cs
   pop   es
   mov   dx,di
   lea   bx,parmblock
   mov   al,0
   mov   ah,4bh
; execute the thing

   int   21h
; here is where we return
   mov   ss,cs:savess
   mov   sp,cs:savesp
   mov   ax,cs
   mov   ds,ax
   mov   es,ax
   jmp   return_pas
endif
if res
      lea   dx,mess2
      mov   ah,9
      int   21h
      mov   ax,texlen
      shl   ax,1
      add   ax,filesize2
      lea   dx,text
      add   dx,ax
      int 27h
endif
if ncom
setpass  endp
mess2 db  'Resident Text gdisplay installed',13,10
      db  'Press Alt-Left Shift-T to view',13,10,'$'
endif
text  equ this byte
cseg2      ends
      end      entry
