passthru = 1  ; 1 is true which means MASM will create the passthroug
              ; version.
;
if passthru
   resident = 0
else
   resident = 1
endif
print macro string
   lea  dx,string
   mov  ah,9
   int  21h
   endm
CSEG        SEGMENT PARA PUBLIC 'CODE'
        ASSUME CS:CSEG,DS:CSEG,SS:CSEG,ES:CSEG
        ORG        100H
ENTPT:        JMP        setpass
;
cright db 13,10,'OKSCR.COM Copyright 1988 by Keith P. Graham',13,10
       db 'Version 0.00 - April 15, 1988',13,10
       db 'Press Alt-Left Shift-O to capture a screen',13,10
       db 'Press Alt-Left Shift-H to capture Hercules Graphics Screens',13,10,10,'$'
; this area is used by the resident and passthrough versions
;
stack   dw   256  dup(0)
stackl  dw   256  dup(0)
;
; keyboard interrupt
int9      dd  0
int9ip   equ word ptr int9
int9cs   equ word ptr int9 + 2
;
; this is the critical error interrupter
int24      dd  0
int24ip   equ word ptr int24
int24cs   equ word ptr int24 + 2
; timer tick
int08     dd  0
int08ip   equ word ptr int08
int08cs   equ word ptr int08 + 2
; key wait
int28     dd  0
int28ip   equ word ptr int28
int28cs   equ word ptr int28 + 2
;
indos   equ this dword
indosip  dw  0
indoscs  dw  0
buffseg dw 0
ticks    dw 0
mode     db 0
herc     db 0
txtswitch db 0
eventsw  db 0
dos_version db 0
savesp   dw  0  ; used by the load program
savess   dw  0
savespl  dw  0  ; local used by int21 4b program
savessl  dw  0
semaphore db  0
vlength  dw 0
vwidth   dw 0
interlace dw 0
vbuff    dw 0
handle   dw  0
filename db '00000000.'
exten    db  'CAP',0
crlf db 13,10
graph_len dw 0

user_pid	dw	?		; User's (calling program's) PID
user_ax		dw	?		; User's AX (temporary storage)
user_sp		dw	?		; User's SP
user_ss		dw	?		;   and SS
user_cc		db	?		; User's break (control-C) check flag
;
tsr_pid	dw 0
;
;
;
; this data is used by the passthru program only
;
if passthru
mess0    db  "OKSCR installing.....",13,10,10,'$'
mess1    db  "OKSCR Uninstalling.....",13,10,10,'$'
command_line db 129 dup(0)
; parmblock is used for the parmeters for the execute
parmblock  dw  0  ; this is the parmblock for execute
           dw command_line
tailds     dw  0
           dw 5ch ; fcb in psp
fcb1       dw  0
           dw 6ch ; fcb in psp
fcb2       dw  0
endif
;
;
; local only stuff used by the programs
width_bytes dw    320
height_pix  dw    6000h
;
;
;
;PCB PC paintbrush
;
PCB_count      dw      128
PCB_BEG        db      0ah,02,01
PCB_BITS_PER_PIXEL db 01
PCB_X          dw      0    ;left pos in bits
PCB_Y          dw      0    ;left y in bits
PCB_LR_X       dw      0    ; right x in bits
PCB_LR_Y       dw      0    ; right y in bits
PCB_hres       dw      640
PCB_vres       Dw      200
               db      0,0,27h
               db      0,0,27h
               db      0,0,27h
               db      0,0,27h
               db      0,0,27h
               db      0,0,27h
               db      0,0,27h
               db      0,0,27h
               db      0,0,27h
               db      0,0,27h
               db      0,0,27h
               db      0,0,27h
               db      0,0,27h
               db      0,0,27h
               db      0,0,27h
               db      0,0,27h
               db      0
PCB_NUM_PLANES db      1
PCB_WIDTH_BYTES dw     80
               db      0,0,0ddh,03
               db      56  dup(0)
;
;
cap_text proc near
; this writes to a screen capture file
     mov   txtswitch,1  ; default graphics
     mov  si,0
     mov  di,0
     push ds
     push es
     mov  es,cs:buffseg
     mov  ds,cs:vbuff
     mov  cx,25
tlloop:
     push cx
     mov  cx,80
tcloop:
     cld
     lodsw
     stosb
     loop  tcloop
; now do a cr lf
     mov   ax,0a0dh
     stosw
     pop   cx
     loop  tlloop
     mov   al,26
     stosb
     pop   ds
     pop   es
     jmp  exit_int9
cap_text endp
closefile:
     mov ah,3eh
     mov  bx,handle
     int  21h
     ret
check_dos proc near
        push  bx
        push  ds
        lds   bx,cs:indos
        cmp   byte ptr ds:[bx],0
        pop   ds
        pop   bx
     ret
check_dos endp
START        PROC        far
;
;
START        ENDP
kbd_int  proc near
; this is the program entry for kbd strike
          pushf
          call cs:int9
          push ax
          mov  al,1
lock  xchg cs:semaphore,al
          cmp  al,1
          jne  good_enter
          pop  ax
          iret
not_us:
          mov  cs:semaphore,0
          pop  ax
          iret
good_enter:
; see if its for us
; we are checking for scan1,scan2 and scanh
          cmp  cs:eventsw,1
          je   not_us
          mov ah,2  ; get shift status
          int 16h
          and  al,10
          cmp  al,10   ; alt left-shift
          jne  not_us
; check for 2 hot keys
          mov  ah,1
          int  16h
          jz   not_us
          cmp  ax,2300h
          je   got_herc
          cmp  ax,1800h
          je   got_other
          jmp  not_us
got_herc:
      mov  cs:herc,1
      jmp  by_herc
got_other:
      mov  cs:herc,0
by_herc:
;
;  go to local stack
      mov   cs:savessl,ss
      mov   cs:savespl,sp
      mov   ax,cs
      mov   ss,ax
      lea   sp,stackl+510
      sti
; save all registers
      push  bx
      push  cx
      push  dx
      push  bp
      push  si
      push  di
      push  ds
      push  es
        mov   ax,cs
        mov   es,ax
        mov   ds,ax
      mov   ah,0
      int   16h   ; clear the keyboard stack
      call  blip
      mov   txtswitch,0  ; default graphics
      mov  interlace,1
;
      mov   al,43h
      mov   mode,al
      cmp   herc,0
      je    not_herc
      jmp   herc_enter
not_herc:
;
;
          mov ah,15
          int 10h
         mov  mode,al
          cmp al,7
          je  do_monot
          cmp al,3
          jle do_colort
          jmp do_graphics
do_monot:
; mono text
         mov  vbuff,0b000h
         mov  eventsw,1
         jmp  cap_text
do_colort:
; color text
         mov  vbuff,0b800h
         mov  eventsw,1
         jmp  cap_text
do_graphics:
         mov  vbuff,0b800h
         mov  interlace,2
         mov  vwidth,80
         mov  vlength,100
         cmp  al,7
         jl   do_dump
         mov  interlace,1
         mov  vbuff,0a000h
         mov  vlength,200
         cmp  al,14
         jle  do_dump
         mov  vlength,350
         cmp  al,11h
         jle  do_dump
         cmp  al,24h
         jle  old_int9
         mov  vlength,480
         cmp  al,50h
         je   do_dump
         cmp  al,25h
         jle  do_dump
         mov  interlace,4
         mov  vbuff,0b800h
         mov  vlength,100
         cmp  al,40h
         je   do_dump
herc_enter:
         mov  interlace,4
         mov  vbuff,0b000h
         mov  vlength,87
         mov  vwidth,90
         cmp  al,43h
         je   do_dump
old_int9:
        call  blop
        jmp   exit_int9
do_dump:
; all paramters are set time to compress the screen
; now set up the parms
        mov   ax,cs
        mov   ds,ax
        mov   es,ax
        call  pcb_out   ; set up the header
        mov   ax,cs
        mov   ds,ax
        mov   es,ax
        call  pcb_write ; compress the file
        mov   cs:eventsw,1
;
exit_int9:
        call  blip
        pop   es
        pop   ds
        pop   di
        pop   si
        pop   bp
        pop   dx
        pop   cx
        pop   bx
; restore the stack
        mov   ss,cs:savessl
        mov   sp,cs:savespl
        pop   ax
        mov   cs:semaphore,0
        iret
kbd_int endp
;
;
;
;
pcb_write  proc  near
; write out the data
;
;
       push    ds
       push    es
       mov    bp,width_bytes
       mov    cx,vlength
       mov    es,buffseg
       mov    ds,vbuff
       mov    di,0
       mov    si,0
; cx has the count of line to write
pcb_loop:
       push   cx    ; save the count of line
       mov    cx,cs:interlace
       push   ds
int_loop:
       push   ds
       push   cx
       push   si
       call   pcb_cline
       pop    si
       pop    cx
       pop    ax
       add    ax,200h
       mov    ds,ax
       loop   int_loop
       add    si,bp
       pop    ds
       pop    cx
       loop   pcb_loop
; di has the amout of the data to write out
       pop    es
       pop    ds
       mov    cs:graph_len,di
       ret
; set upt the compression loop
pcb_cline:
       cld
       lodsb    ; prime the pump
       mov   ah,al
       mov   dx,0   ; counter
       mov   bx,bp ; bytes in a line ; how many bytes in a line?
       dec   bx
       cmp   bx,0
       jle   done_pcb_line
pcb_loop1:
       dec   bx
       cmp   bx,0
       jl    done_pcb_line
       lodsb
       xchg  ah,al
       cmp   ah,al
       je    got_pcb_repeat
; do we have a repeat in the works
       cmp   dx,0
       jne   store_count
       push  ax
       mov   ah,0
       cmp   ax,63
       pop   ax
       jg    store_count
       jmp   store_pcb
got_pcb_repeat:
       cmp   dx,62
       jge   store_count
       inc   dx
       jmp   pcb_loop1
store_count:
       inc  dx
       or   dx,0c0h
       push ax
       mov  al,dl
       stosb
       pop  ax
       mov  dx,0
store_pcb:
       stosb
       jmp   pcb_loop1
done_pcb_line:
 ; have run out of bytes in line
; ah has not been handled
       mov   al,ah
       cmp   dx,0
       jg    repeat_pcb2
       mov   ah,0
       cmp   ax,63
       jle   store_pcb2
repeat_pcb2:
       inc  dx
       or   dl,0c0h
       push ax
       mov  al,dl
       stosb
       pop  ax
store_pcb2:
       stosb
       ret
pcb_write  endp

;
PCB_out      PROC    NEAR
public PCB_out
       MOV   ax,vwidth
       mov   pcb_width_bytes,ax
       mov   width_bytes,ax
       shl   ax,1
       shl   ax,1
       shl   ax,1
       dec   ax
       mov   pcb_lr_x,ax
       MOV   ax,vlength
       mul   interlace
       mov   height_pix,ax
       dec   ax
       mov   PCB_LR_y,ax
       ret
PCB_out    ENDP
openfile  proc near
; creates an output file
; check the time to name the file
     mov  ax,cs
     mov  ds,ax
     mov  es,ax
     mov  ah,2ch
     int  21h
     mov  ax,cx
; ax:dx has the time
     lea  di,filename
     mov  cx,10
     push ax
     mov  al,ah
     mov  ah,0
     div  cl
     or   ax,3030h
     cld
     stosw
     pop   ax
     mov  ah,0
     div  cl
     or   ax,3030h
     stosw
     mov  ax,dx
     push ax
     mov  al,ah
     mov  ah,0
     div  cl
     or   ax,3030h
     stosw
     pop   ax
     mov  ah,0
     div  cl
     or   ax,3030h
     stosw
; create the file
     mov   ah,3ch
     lea   dx,filename
     mov   cx,0
     int   21h
     jc    bad_open
     mov   handle,ax
     clc
     ret
bad_open:
     call  blop
     call  blop
     call blop
     stc
     ret
openfile  endp
writefile proc near
; writes out a file and returns results in ax
; cx has the number of bytes to write, dx has the location
       push bx
       mov  bx,cs:handle
       mov  ah,40h
       int  21h
       jc   bad_write
       cmp  ax,cx
       jne  bad_write
       pop  bx
       clc
       ret
bad_write:
       pop  bx
       stc
       ret
writefile endp
;
;
crit_err  proc near
	mov	al,0			; INT 24h "ignore" flag
	cmp	cs:dos_version,3	; DOS 3.xx or better?
	jb	int_24h_exit
	mov	al,3			; Yes - return "fail" flag
	iret
int_24h_exit:
        mov     al,1   ; exit?
	iret
crit_err  endp

InTSR	PROC	near
; this routine is executed to save the break and the
; crit err
        mov     ax,cs
        mov     ds,ax
        mov    es,ax

;	mov	ax,3300h		; DOS service:
;	int	21h			;   Get break flag
;	mov	user_cc,dl		; Save user's break flag

;	mov	dl,0h
;	mov	ax,3301h		; DOS service:
;	int	21h			;   Set break flag (0 = no break check)

        push    es
 	mov	ax,3524h		; DOS service:
 	int	21h			;   Get INT 24h vector
 	mov	int24ip,bx	; Save user's critical error vector
 	mov	int24cs,es
        pop     es
 	mov	dx,offset crit_err 	; Point to our critical error handler
 	mov	ax,2524h		; DOS service:
 	int	21h			;   Set INT 24h vector

	mov	ah,51h			; DOS service:
	int	21h			;   Get Process ID
	mov	user_pid,bx		; Save user's PID

	mov	bx,cs     		; Load our Process ID
	mov	ah,50h			; DOS service:
	int	21h			;   Set PID

	ret

InTSR	ENDP


;
;	Restore DOS's state for the user's program.  Flags and vectors
;	changed by InTSR are restored.
;

OutTSR	PROC	near

        mov     ax,cs
        mov     ds,ax
        mov    es,ax

	mov	bx,user_pid		; Load user's PID
	mov	ah,50h			; DOS service:
	int	21h			;   Set Process ID


 	mov	dx,int24ip       	; Point to user's critical error
 	mov	ax,int24cs      	;   handler
 	push	ds
 	mov	ds,ax
 	mov	ax,2524h		; DOS service:
 	int	21h			;   Set INT 24h vector
 	pop	ds

;	mov	dl,user_cc		; Get user's break flag
;	mov	ax,3301h		; DOS service:
;	int	21h			;   Set break flag

	ret

OutTSR	ENDP


;
;
;
;
;
; the tone routines produce glisandos based on the value of si
blip    proc  near
        push  si
        mov   si,30
        call  tone
        pop   si
        ret
blip    endp
blop    proc  near
        push  si
        mov   si,-30
        call  tone
        pop   si
        ret
blop    endp
tone    proc  near
        sti
        push  ax
        push  bx
        push  cx
        push  dx
        mov   dx,3    ; tone rate
        mov   bx,240 ; starting freq
        mov   cx,750  ; ending frequency
        cmp   si,0
        jg    do_blip
; here we do blop
        mov   bx,630  ; starting freq
        mov   cx,150  ; ending frequency
do_blip:
; turn on tone
i0:
        push  cx
        push  bx
        in     al,61h
        or     al,3
        out    61h,al
; loop parameters
        mov    cx,bx
 ; set frequency
        mov    dx,12h
        mov    ax,34deh
        div    cx
        mov    cx,ax
; set tone
        mov    al,cl
        out    42h,al
        mov    al,ch
        out    42h,al
i2:     loop i2
        pop    bx
        pop    cx
        cmp    bx,cx
        je     ip3
        add    bx,si
        jmp    i0
ip3:
 ;turn off tone
        in  al,61h
        and al,11111100b
        out 61h,al
        pop  dx
        pop  cx
        pop  bx
        pop  ax
        ret
tone    endp
keywait:
; int 28 is the dos wait for keystroke interrupt and it is only
; issued while dos is getting a keystroke and its state
; is saved. This prevents dos from locking up the machine
; and allows us to use the 28
       pushf
       call   cs:int28
; here we do the lock stuff to keep everyone out while ticking
        sti
        push  ax
        mov  al,1
lock    xchg cs:semaphore,al
        test al,al
        jz   int28_check
        pop  ax
        iret
int28_return:
        mov  cs:semaphore,0
        pop  ax
        iret
int28_check:
; check to see if we are working, once every 5 ticks
        cmp  cs:eventsw,0
        je   int28_return
; we can do dos calls!!!
        call  do_event
        jmp   int28_return


timer:
       pushf
       call   cs:int08
; here we do the lock stuff to keep everyone out while ticking
        push  ax
        mov  al,1
lock    xchg cs:semaphore,al
        test al,al
        jz   int08_check
        pop  ax
        iret
int08_return:
        mov  cs:semaphore,0
        pop  ax
        iret
int08_check:
; check to see if we are working, once every 3 ticks
        cmp  cs:eventsw,0
        je   int08_return
        inc  cs:ticks
        cmp  cs:ticks,2
        jle  int08_return
; here we are
        mov  cs:ticks,0
; there is an event and we are in it, can we do anything?
;
        push  bx
        push  ds
        lds   bx,cs:indos
        cmp   byte ptr ds:[bx],0
        pop   ds
        pop   bx
        je    good_indos
        jmp  int08_return
good_indos:
; we can do dos calls!!!
        call  do_event
        jmp   int08_return
do_event:
; save all registers
      push  ax
; save the local stack
      cli
      mov   cs:savessl,ss
      mov   cs:savespl,sp
      mov   ax,cs
      mov   ss,ax
      lea   sp,stackl+510
      sti
      push  bx
      push  cx
      push  dx
      push  bp
      push  si
      push  di
      push  ds
      push  es
        mov   ax,cs
        mov   es,ax
        mov   ds,ax
; do our stuff
     mov eventsw,0
     call InTSR
; we into an event, is it a text or a PCB event?
     cmp  txtswitch,1
     jne  pcx_event
; its a text event, do text stuff
     lea  di,exten
     cld
     mov   ax,'AC'
     stosw
     mov   al,'P'
     stosb
     mov   al,0
     stosb
     call openfile
     jc   leave_text2
     mov  cx,2051
     mov  dx,0
     push  ds
     mov   ds,buffseg
     call writefile
     pop   ds
leave_text2:
     call closefile
     call outTSR
        call  blip
        pop   es
        pop   ds
        pop   di
        pop   si
        pop   bp
        pop   dx
        pop   cx
        pop   bx
        mov   ss,cs:savessl
        mov   sp,cs:savespl
        pop   ax
        ret
pcx_event:
; here is a graphics event
        mov   ax,cs
        mov   es,ax
        mov   ds,ax
     lea  di,exten
     cld
     mov   ax,'CP'
     stosw
     mov   al,'X'
     stosb
     mov   al,0
     stosb
     call openfile ; opens the file
     jc   leave_text2
     lea  dx,pcb_beg
     mov   cx,128
     call writefile
     jc   leave_text2
     mov  dx,0
     push ds
     mov  ds,buffseg
     mov  cx,cs:graph_len
     call writefile
     pop  ds
     jc   leave_text2
     call closefile
     jmp   leave_text2
;
;
;
setpass  proc  near
;check dos version
	mov	ah,30h
	int	21h
	mov	dos_version,al
	test	al,al
	jnz	sp1
	print   err0
	int	20h
sp1:
; set up a local stack
        lea  sp,stack+510
        print cright
        print mess0
	mov	ah,51h			; DOS service:
	int	21h			;   Get Process ID
	mov	tsr_pid,bx		; Save TSR's PID

;
; redirect interrupts here
;
; redirect keyboard, 28 and timer tick
;
;  09 is the keyboard
        push  es
        mov   ax,3509h
        int   21h
        mov   int9cs,es
        mov   int9ip,bx
        pop   es
        mov   ah,25h
        mov   al,9h
        lea   dx,kbd_int
        int   21h
;
;  28 is the keywait
        push  es
        mov   ax,3528h
        int   21h
        mov   int28cs,es
        mov   int28ip,bx
        pop   es
        mov   ah,25h
        mov   al,28h
        lea   dx,keywait
        int   21h
;
;  08 is the timer tick
        push  es
        mov   ax,3508h
        int   21h
        mov   int08cs,es
        mov   int08ip,bx
        pop   es
        mov   ah,25h
        mov   al,08h
        lea   dx,timer
        int   21h
;
; get the INDOS flag
        push  es
        mov   ah,34h
        int   21h
        mov   indosip,bx
        mov   indoscs,es
        pop   es
;
if  passthru
;
;  prepare for the exec function
; shrink memory
   lea   bx,last_byte    ; last byte of program
   add   bx,15           ; trick to round up
   mov   cl,4
   shr   bx,cl           ; divide by 16 to get number of 16 byte blocks
   mov   ax,cs
   add   ax,bx
   mov   buffseg,ax     ; segment of buffer
   add   bx,1000h         ; 64k for buffer
   mov   ah,4ah          ; shrink
   int   21h
; create the commandline
;
; the command line has to start with /C and then the command
; and then end with a carriage return. It must have a byte at
; the front saying how long it is
   cld
   lea   di,command_line+1
   mov   al,'/'
   stosb
   mov   al,'C'
   stosb
   mov   al,' '
   stosb
; now copy the real command line in
   mov   si,81h
   mov   cl,byte ptr ds:[80h]
   mov   ch,0
   push  cx
   cmp   cx,0
   je    no_move
   cld
rep movsb
no_move:
   pop   cx
   add   cx,3
   mov   command_line,cl
; set up the control block with segment information
   mov    tailds,ds
   mov    fcb1,ds
   mov    fcb2,ds
;
; find the comspec
;
   mov    es,word ptr  ds:[2ch]
   mov     di,0
   mov     cx,255
env_loop:
   cld
   mov   al,'='
repne   scasb
; if there is no comspec, there is something wrong with the system
   cmp   word ptr es:[di-3],'CE'
   jne   env_loop
   cmp   word ptr es:[di-5],'PS'
   jne   env_loop
   cmp   word ptr es:[di-7],'MO'
   jne   env_loop
   cmp   byte ptr es:[di-8],'C'
   jne   env_loop
; got the comspec
;
; save the stack
;
   mov   savess,ss
   mov   savesp,sp
;
; set up the segment registers
;
; the comspec segment is in ES and should be in DS
;
   push  es
   pop   ds
   push  cs
   pop   es
   mov   dx,di
   lea   bx,parmblock
   mov   al,0
   mov   ah,4bh
; execute the thing
   int   21h
; here is where we return
   mov   ss,cs:savess
   mov   sp,cs:savesp
   mov   ax,cs
   mov   ds,ax
   mov   es,ax
;
; now reset the interrupts so we can leave
;
        push  ds
        lds   dx,int9
        mov   ah,25h
        mov   al,9h
        int   21h
        pop   ds
;
        push  ds
        lds   dx,int08
        mov   ah,25h
        mov   al,08h
        int   21h
        pop   ds
;
        push  ds
        lds   dx,int28
        mov   ah,25h
        mov   al,28h
        int   21h
        pop   ds
; say that we did it
   lea   dx,mess1
   mov   ah,9
   int  21h
endif
if resident
        lea   dx,setpass  ; don't make the install portion resident
        int  27h
endif
     int   20h
setpass  endp
last_byte equ this byte
err0   db 13,10,7,'Wrong DOS Version.',13,10,'$'
CSEG        ENDS
        END        ENTPT
;
;

