cseg segment para public 'CODE'
    assume cs:cseg,ds:cseg,es:cseg
    org  100h
; this routine is used to convert a basic MKS$ into a double
; word integer
; on entry si points to the MKS$
start: jmp  main
test1  db 00dh,12h,01ch,91h
main: ; test of sconvert
      lea  si,test1
      call sconv
      int  20h
sconv proc  near
; get the exponent
      mov  cl,ds:[si+3]
      mov  ch,0
      sub  cx,80h
; cx has the exponent
; get the low word and the sign
      mov  ax,ds:[si+1]
      mov  bp,1
      test ah,80h
      jz   posit
      mov  bp,-1
posit:
      or   ah,80h
      mov  dl,byte ptr ds:[si]
      mov  dh,0
; right now ax:dx has the integer which must be shifted
      mov  bx,0
      cmp  cx,0
      je   zero_cx
      jg   shift_left
shift_right:
; the amount in ax:dx must be shifted into the fraction
; we are not dealing with high precision fractional amounts
      neg  cx
sr_loop:
      shr  ax,1
      loop  sr_loop
      jmp   zero_cx
shift_left:
; this shifts to left (most common)
; ax goes to bx, dx goes to ax
      mov  di,0
sl_loop:
      clc
      rcl  dx,1
      rcl  ax,1
      rcl  bx,1
      rcl  di,1
      loop sl_loop
; the number is now in di:bx:ax:dx
; dx can go away as it is too small
      mov  dx,di
      xchg bx,ax
; bx now has the remaining fractional
; dx:ax has the integer portion
      jmp  end_sconv
zero_cx:
; here the ax value is all less than 1
      mov   bx,ax
      mov   ax,0
      mov   dx,0
;
end_sconv:
; here dx:ax has a normal type dw integer
; bx has the fractional portion of the floating point
      ret
sconv endp
cseg ends
   end start
