CSEG        SEGMENT PARA PUBLIC 'CODE'
        ASSUME CS:CSEG,DS:CSEG,SS:CSEG,ES:CSEG ;ALREADY SET BY DOS LOADER
        ORG        100H                        ;SKIP TO END OF THE PSP
ENTPT:        JMP        start                        ;COM FILE ENTRY ALWAYS AT 100H
rows     equ 25
cols     equ 80
windx    equ -1
windy    equ -1
windsi  dw 0
logo  equ this byte
include c:fbnl.asm
wsave  dw 2000   dup(0000h)
done   db 2000   dup(00h)
blanks dw 2000 dup (0700h)
bhpage   db  0
cursor   dw  0
cursmode dw  0
boxc   equ this word
boxx1     db  0
boxy1     db  0
boxd   equ this word
boxx2     db  0
boxy2     db  0
include c:fd.asm
include c:cti.asm
START        PROC        NEAR
        cmp  byte ptr ds:[5dh],'2'
        jne  no_com2
        mov  comport,1
no_com2:
        mov  ah,0
        mov  dl,comport
        call initcom
        call setbaud
        call getcurs
        call getwind
        call blip
        lea  dx,logo
        mov  windsi,dx
        call putwind2
        mov  cx,5
        call waitsec
        mov  ah,0
        int  16h
        lea  dx,blanks
        mov  windsi,dx
        call putwind
        mov ah,2
        mov bh,0
        mov  dx,0
        int  10h
;       call setbaud
        call dial
        call commx
exit_prog:
        lea  dx,wsave
        mov  windsi,dx
        call  cleandone
        call putwind
;       call retwind
        call retcurs
        push cs
        pop  ds
        int  20h
START        ENDP
cleandone  proc near
       push  cx
        mov  cx,2000
        mov  ax,0
        lea  di,done
        cld
rep     stosb
        pop  cx
        ret
cleandone  endp
putwind3  proc  near
         call  cleandone
; this routine will page from upper left to lower right
        mov   boxx1,-1
        mov   boxy1,0
        mov   boxx2,0
        mov   boxy2,-1
pw30:
        inc   boxx1
        inc   boxy2
        call  liner
        cmp   boxy2,24
        jl    pw30
pw31:
        inc   boxx1
        inc   boxx2
        call liner
        cmp   boxx1,79
        jl   pw31
pw32:
        inc  boxy1
        inc  boxx2
        call liner
        cmp  boxx2,79
        jl   pw32
        ret
putwind3 endp
putwind2  proc  near
         call  cleandone
          mov  boxx1,39
          mov  boxy1,12
; do top row
         mov   boxd,0
         mov   cx,79
pwloop1:
         call  liner
         inc   boxx2
         loop  pwloop1
         mov   cx,24
pwloop2:
         call  liner
         inc   boxy2
         loop  pwloop2
         mov   cx,79
pwloop3:
         call  liner
         dec   boxx2
         loop  pwloop3
         mov   cx,24
pwloop4:
         call  liner
         dec   boxy2
         loop  pwloop4
         ret
putwind2  endp
liner    proc  near
; this routine draws a line by recursively connecting dots
         push  cx
         mov   cl,boxx1
         mov   ch,boxy1
         mov   dl,boxx2
         mov   dh,boxy2
         push  dx
         push  cx
         mov   dx,cx
         call  putloc
         pop   cx
         pop   dx
; dx has one end and cx has the other
         push  dx
         call  linerec
         pop   dx
         pop   cx
         ret
liner    endp
slope    dw  0
linerec  proc  near
; this is the recursive function
         cmp   cx,boxd
         jne   lr01
         ret
lr01:
         cmp   dx,boxc
         jne   lr02
         ret
lr02:
         cmp   cx,dx
         jne   lr03
         ret
lr03:
         push  dx
         push  cx
; check to see if they are one appart
         sub   cl,dl
         sub   ch,dh
         cmp   cl,0
         je    recend1
         cmp   cl,1
         je    recend1
         cmp   cl,-1
         je    recend1
         jmp   reccont
recend1:
         cmp   ch,0
         je    recend
         cmp   ch,1
         je    recend
         cmp   ch,-1
         je    recend
         jmp   reccont
recend:
         pop   cx
         pop   dx
         call  lineb
         ret
reccont:
         pop   cx
         pop   dx
         push  dx
         push  cx
; this is the recursive part
; divide by 2 and do the cx side
         mov   ax,cx
         add   al,dl
         shr   al,1
         add   ah,dh
         shr   ah,1
         mov   dx,ax
         call  linerec
         pop   cx
         pop   dx
         push  dx
         push  cx
; divide by 2 and do the dx side
         mov   ax,dx
         add   al,cl
         inc   al
         shr   al,1
         add   ah,ch
         inc   ah
         shr   ah,1
         mov   cx,ax
         call  linerec
         pop   cx
         pop   dx
         ret
linerec  endp
lineb    proc  near
         push  dx
         push  cx
         call  putloc
         mov   dx,cx
         call  putloc
         pop   cx
         pop   dx
         ret
lineb    endp
boxx      dw  0
boxy      dw  0
putwind   proc  near
         call  cleandone
; start at the center
          mov  boxx,0
          mov  boxy,1
          mov  dl,39
          mov  dh,12
;  first loop to the right
topput:
; now loop down
           mov  cx,boxy
downbox:
          call  putloc
          add   dl,1
          call  putloc
          add   dl,1
          call  putloc
          sub   dl,2
          add   dh,1
          loop  downbox
; now loop left
          add   boxx,3
          mov   cx,boxx
          add   dl,3
leftbox:
          sub   dl,1
          call  putloc
          loop  leftbox
; now loop up
          add   dh,1
          sub   dl,3
          inc   boxy
          mov   cx,boxy
upbox:
          sub   dh,1
          call  putloc
          add   dl,1
          call  putloc
          add   dl,1
          call  putloc
          sub   dl,2
          loop  upbox
          sub   dh,1
          sub   dl,1
          add   boxx,3
          mov   cx,boxx
rightbox:
          add   dl,1
          call  putloc
          loop rightbox
          add   dl,1
          inc   boxy
          cmp   boxx,79
          jg    endput
          jmp   topput
endput:
          ret
putwind   endp
putloc    proc  near
; dx has the cursor location
; dh has the row, dl the column
          cmp  dl,0
          jge  goodl2
          mov  boxx,80
          ret
goodl2:
          cmp  dl,79
          jle  goodl
          mov  boxx,80
          ret
goodl:
          cmp  dh,0
          jge  goodh2
          ret
goodh2:
          cmp  dh,24
          jle  goodh
          ret
goodh:
          push cx
          push dx
          mov  al,dh
          mov  ah,0
          mov  cx,80
          mul  cl
          mov  dh,0
          add  ax,dx
          shl  ax,1
          mov  bx,ax
          mov  si,windsi
          add  si,bx
; locate the cursor
          shr  bx,1
          cmp  done[bx],1
          jne  oktoput
          pop  dx
          pop  cx
          ret
oktoput:
          mov  done[bx],1
          pop  dx
          push  dx
          mov  ah,2
          mov  bh,bhpage
          int  10h
; put word at cursor
          lodsw
      ;   ah has the  attribute, al, has the character
          mov  bl,ah
          mov  ah,9
          mov  bh,bhpage
          mov  cx,1
          int  10h
          pop  dx
          pop  cx
          ret
putloc    endp
getwind   proc near
; here we have to get the current window
          lea  di,wsave
          mov  cx,rows
          mov  dh,windy
gwloop:
          push cx
          add  dh,1
          mov  dl,windx
          mov  cx,cols
gwloop2:
          inc  dl
          mov  ah,2
          mov  bh,bhpage
          int  10h
; get word at cursor
          mov  ah,8
          mov  bx,0
          int  10h
          stosw
          loop  gwloop2
          pop  cx
          loop gwloop
          ret
getwind   endp
retwind   proc  near
          lea  si,wsave
; locate at the line 1 position 10
          mov  cx,rows
          mov  dh,windy
rwloop:
          push cx
          add  dh,1
          mov  dl,windx
          mov  cx,cols
rwloop2:
          push cx
          inc  dl
          mov  ah,2
          mov  bh,bhpage
          int  10h
; put word at cursor
          lodsw
      ;   ah has the  attribute, al, has the character
          mov  bl,ah
          mov  ah,9
          mov  bh,bhpage
          mov  cx,1
          int  10h
          pop  cx
          loop  rwloop2
          pop  cx
          loop rwloop
          ret
retwind   endp
getcurs   proc  near
; get video state
          mov ah,15
          int 10h
          mov bhpage,bh
          mov ah,3
          mov bh,bhpage
          int  10h
          mov  cursor,dx
          mov  cursmode,cx
          ret
getcurs   endp
retcurs   proc  near
          mov ah,2
          mov  dx,cursor
          mov bh,bhpage
          int  10h
          ret
retcurs   endp
blip    proc  near
        mov   bx,250  ; starting freq
        mov   cx,750  ; ending frequency
        mov   dx,3    ; tone rate
; turn on tone
i0:
        push  cx
        push  bx
        in     al,61h
        or     al,3
        out    61h,al
; loop parameters
        mov    si,32
        cmp    bx,cx
        jle    i1
        neg    si
i1:
        mov    cx,bx
 ; set frequency
        push   dx
        mov    dx,12h
        mov    ax,34deh
        div    cx
        mov    cx,ax
        pop    dx
; set tone
        mov    al,cl
        out    42h,al
        mov    al,ch
        out    42h,al
; mov   cx,dx
i2:     loop i2
        pop    bx
        pop    cx
        cmp    bx,cx
        jg     ip3
        add    bx,si
        jmp    i0
ip3:
 ;turn off tone
        in  al,61h
        and al,11111100b
        out 61h,al
        ret
blip    endp
CSEG        ENDS
        END        ENTPT
