climit equ 255
print macro string
   lea dx, string
   mov  ah,9
   int  21h
   endm
cseg segment 'CODE'
   assume cs:cseg,ds:cseg,es:cseg,ss:cseg
   org   100h
entry:
        jmp   start
hello  db 'hello',13,10
    db 'Copyright 1989 by Keith P. Graham',13,10,'$'

error1 db 'Invalid file name or file not found.',13,10,'$'
error2 db 'Error Allocating Memory',13,10,'$'
error3 db 'Error Reading File',13,10,'$'
error4 db 'Error creating output file.',13,10,'$'
error5 db 'Error Writing File (disk full?)',13,10,'$'
file1     db   65  dup(0)
file_size dw 0
file2     db   65  dup(0)
handlei dw 0
bufferi dw 0
handleo dw 0
buffero dw 0
switch1 db 0
switch2 db 0
nodespace dw 0
buffloc  dw 0
buffsize dw 0
out_bytes dw 0
out_loc  dw 0
free   dw 0
nodes  struc
  first  dw ?
  side   dw ?
  who    dw ?
  rank   dw ?
nodes    ends

;
goodbye db 'Bytes read:    '
rbytes  db '         ',13,10
        db 'Bytes written: '
bwrit   db '         ',13,10
        db 'Codes written: '
cwrit   db '         ',13,10
       db 13,10,'$'

buck1  dw  0,0
buck2  dw  0,0
buck3  dw  0,0
buck4  dw  0,0
;
;

;
;

snake:
;
; this is the routine that reads the file and calculates the snake
; the rank is then output in dx
;
    call get_byte
    jnc  sn_00
    ret
sn_00:
    mov  dx,-1
    mov  bp,ax
    mov  di,ax
    shl  di,1
    shl  di,1
    shl  di,1
label_1:
    call put_code
    mov  bx,bp
;   cmp  bp,100h
    cmp  dx,2
    jl   l1_1
    mov  bx,es:[di].who
    shl  bx,1
    shl  bx,1
    shl  bx,1
    mov  di,bx
    jmp  sn_01
l1_1:
    shl  bx,1
    shl  bx,1
    shl  bx,1
    mov  di,bx
    call get_byte
    jnc  sn_01
    ret
sn_01:
    mov  dx,0
    mov  bp,ax
label_2:
    inc  dx
    cmp  dx,2
    jg   label_1
    cmp  es:[di].first,-1
    jne  trace_first
    call add_first
; have an ax here not yet matched
    jmp  label_1
trace_first:
    mov  di,es:[di].first
    mov  si,di
    cmp  es:[di].who,ax
    jne  check_side
    mov  bp,es:[di].rank
label_4:
    call get_byte
    jnc  label_2
    call put_code
    ret
check_side:
    cmp  es:[si].side,-1
    jne  trace_side
    call add_side
    jmp  label_1
trace_side:
    mov  si,es:[si].side
    cmp  es:[si].who,ax
    jne  check_side
    mov  di,si
    mov  bp,es:[di].rank
    jmp  label_4
;
;
add_first:
    cmp  es:[bx].rank,climit
    jl   af_1
    ret
af_1:
; have to add a free node, set carry on failure
    call  get_free
    jc    af_2
    mov   es:[di].first,si
    clc
    ret
af_2:
    call  init_nodes
    mov   es:[bx].first,si
    stc
     ret
add_side:
    cmp  es:[bx].rank,climit
    jl   as_1
    ret
as_1:
; have to add a side, to guy in si
    push  di
    push  si
    mov   di,si
    call  get_free
    jc    as_2
    mov   es:[di].side,si
    pop   si
    pop   di
    clc
    ret
as_2:
    call  init_nodes
    mov   es:[bx].first,si  ; adds a first after re-init of nodes
    pop   si
    pop   di
    stc
     ret
;
;
get_free:
; returns with a free node in si
    push  di
    push  cx
    mov   di,free
    cmp   di,-1
    je    no_free
    mov   si,es:[di].first
    mov   free,si
    mov   es:[di].first,-1
    mov   es:[di].side,-1
    mov   es:[di].who,ax
    cmp   dx,2
    jge   gf_1
    mov   cx,ax
    jmp   gf_2
gf_1:
    mov   cx,es:[bx].rank
    inc   cx
    mov   es:[bx].rank,cx
gf_2:
    mov   es:[di].rank,cx
    mov   si,di
    pop   cx
    pop   di
    clc
    ret
no_free:
    mov   si,di
    pop   dx
    pop   di
    stc
    ret
;
;
largest  dw 0
    bits dw 8
    bitw dw 512
out_count dw 0,0
;
put_code:
   add  buck3,1
   adc  buck3+2,0
; this puts out a word in dx out to the file
    cmp   bp,largest
    jle   put_c2
    cmp   bp,climit+1
    je    put_c2
    mov   largest,bp
put_c2:
    push  ax
    mov   ax,bits
    push  di
    mov   di,out_bytes
    push  es
    mov   es,buffero
    cld
    mov   ax,bp
    stosw
    pop   es
    mov   out_bytes,di
;
    pop   di
    pop   ax
    cmp   out_bytes,4000h
    jge   clear_buff
    clc
    ret
clear_buff:
    call  write_file
    ret



get_byte:
   add  buck1,1
   adc  buck1+2,0
; gets a byte from the input stream into ax
   push si
   mov  si,buffloc
   push ds
   mov  ds,bufferi
   cld
   lodsb
   mov  ah,0
   pop  ds
   mov  buffloc,si
   cmp  si,buffsize
   pop  si
   ja   fill_buff
   clc
   ret
fill_buff:
   push di
   call  read_file
    pop di
    ret
init_nodes2:
    push  dx
    mov   dx,climit+1
    call  put_code
    pop   dx
    push  ax
    pop   ax
init_nodes:
    push  ax
    mov   ax,0e07h
    int   10h
    push  cx
    push  di
    mov   bits,8
    mov   bitw,512
    mov   cx,256
    mov   di,0
    mov   ax,0
in_0:
    mov   es:[di].who,ax
    mov   es:[di].rank,255
    mov   es:[di].first,-1
    mov   es:[di].side,-1
    add   di,8
    inc   ax
    loop  in_0
    mov   cx,8000
    mov   ax,di
    mov   free,di
in_1:
    add   ax,8
    mov   es:[di].first,ax
    mov   di,ax
    loop  in_1
    mov   es:[di].first,-1
    mov   es:[di].side,-1
    pop   di
    pop   cx
    pop   ax
    ret
start:
    print hello
    call  parse_line
    jc    error_exit
    call  open_file
    jc    error_exit
    call  create_file
    jc    error_exit
    call  memory_alloc
    jc    error_exit
    call  read_file
    jc    error_exit
    push  es
    mov   es,nodespace
    call  init_nodes
    call  snake
    pop   es
good_exit:
    cmp  out_bytes,0
    je    ge_1
    call  write_file
ge_1:
    call  stats
    lea   dx,goodbye
error_exit:
    mov   ax,cs
    mov   ds,ax
    mov   ah,9
    int   21h
    int   20h
;
;
write_file:
; get the file into memory
; cx has the size of file to write
    push  ax
    push  bx
    push  cx
    push  dx
    push  ds
    mov   bx,handleo
    mov   dx,0
    mov   cx,out_bytes
    mov   out_bytes,0
    mov   ds,buffero
    mov    ah,40h
    int    21h
    pop    ds
    jc     bad_write
    cmp    ax,cx
    je     good_write
bad_write:
    pop   dx
    pop   cx
    pop   bx
    pop   ax
    lea dx,error5
    stc
    ret
good_write:
    pop   dx
    pop   cx
    pop   bx
    pop   ax
    clc
    ret
;
;
stats:
    lea  di,rbytes
    mov  ax,buck1
    mov  dx,buck1+2
    call bin2hex
    lea  di,bwrit
    mov  ax,buck2
    mov  dx,buck2+2
    call bin2hex
    lea  di,cwrit
    mov  ax,buck3
    mov  dx,buck3+2
    call bin2hex
    ret
bin2hex:
    mov   cx,10000
    div   cx
    mov   cl,10
    div   cl
    or    ax,3030h
    stosw
    mov   ax,dx
    mov   dx,0
    mov   cx,100
    div   cx
    mov   cl,10
    div   cl
    or    ax,3030h
    stosw
    mov   ax,dx
    div   cl
    or    ax,3030h
    stosw
    ret
;

;

;
create_file:
    mov  ax,3c00h
    mov  cx,0
    lea  dx,file2
    int  21h
    jnc  good_create
    lea  dx,error4
    stc
    ret
good_create:
    mov  handleo,ax
    clc
    ret
;
read_file:
; get the file into memory
    push  ax
    push  bx
    push  cx
    push  dx
    push  ds
    mov   bx,handlei
    mov   dx,0
    mov   cx,03000h
    mov   ds,bufferi
    mov    ah,3fh
    int    21h
    pop    ds
    jnc    good_read
bad_read:
    pop   dx
    pop   cx
    pop   bx
    pop   ax
    lea dx,error3
    stc
    ret
good_read:
    cmp   ax,0
    je    bad_read
    mov   buffsize,ax
    mov   buffloc,0
    pop   dx
    pop   cx
    pop   bx
    pop   ax
    clc
    ret
open_file:
; opens the file for reading
    mov  ax,3d10h
    lea  dx,file1
    int  21h
    jnc  good_open
    lea  dx,error1
    stc
    ret
good_open:
    mov  handlei,ax
    clc
    ret
;
last_byte equ this word
parse_line:
; strategy is you have to scan for switches
; then you look for an infile and an outfile
;
    mov  cl,byte ptr ds:[80h]
    mov  ch,0
    mov  di,81h
    mov  bx,0
    cld
pl0:
    mov  al,'/'
repne scasb
    jne  pl2
    mov  byte ptr ds:[di-1],20h
    mov  al,byte ptr ds:[di]
    mov  byte ptr ds:[di],20h
    or   al,32
    mov  switch1[bx],al
    inc  bx
    cmp  cx,0
    jle  pl2
    jmp  pl0
pl2:
    mov  si,81h
    lea  di,file1
    mov  cl,byte ptr ds:[80h]
    mov  ch,0
    cmp  cx,3
    jge  ok_fname
bad_fname:
    lea dx,error1
    stc
    ret
ok_fname:
; set up file
    lodsb
    cmp  al,13
    je   bad_fname
    cmp  al,20h
    je   ok_fname
    cmp  al,9
    je   ok_fname
parse1:
    stosb
    lodsb
    cmp  al,13
    je   parse2
    cmp  al,20h
    je   parse2
    cmp  al,9
    jne  parse1
parse2:
    mov  ax,0
    stosw
    lea  di,file2
parse3:
    lodsb
    cmp  al,13
    je   bad_fname
    cmp  al,20h
    je   parse3
    cmp  al,9
    je   parse3
parse4:
    stosb
    lodsb
    cmp  al,13
    je   parse5
    cmp  al,20h
    je   parse5
    cmp  al,9
    jne  parse4
parse5:
    mov  ax,0
    stosw
    clc
    ret
;
memory_alloc:
; allocates memory
; shrink
;
    mov  cx,0
    lea  ax,last_byte+512
    add  ax,15
    shr  ax,1
    shr  ax,1
    shr  ax,1
    shr  ax,1
    mov  bx,ds
    add  bx,ax
    mov  ax,4a00h
    int  21h
    jnc  good_shrink
bad_mem:
    lea dx,error2
    stc
    ret
good_shrink:
; allocate stack
    mov  ah,48h
    mov  bx,100h ; 256*16 = 4096
    int  21h
    jc   bad_mem
    pop  bx
    mov  ss,ax
    mov  sp,4094
    push bx
; allocade nodespace
    mov  ah,48h
    mov  bx,1000h ; 64k for file reading
    int  21h
    jc   bad_mem
    mov  es:nodespace,ax
; allocate 64k buffer for file access
    mov  ah,48h
    mov  bx,1000h ; 64k for file reading
    int  21h
    jc   bad_mem
    mov  es:bufferi,ax
    mov  ah,48h
    mov  bx,1000h ; 64k for file reading
    int  21h
    jc   bad_mem
    mov  es:buffero,ax
    clc
    ret
cseg ends
    end entry
