;
;
compress:
     cld
     call  get_byte
     jnc   cont_compress
     clc
     ret
cont_compress:
;
; al has the character to decode ; es has the node space
     mov   di,ax
     shl   di,1    ; x 2
     shl   di,1    ; x 4
     add   di,ax   ; x 5
     mov   dx,0
     call  trace
    jnc   compress
     ret
;
;
trace:
; di has the root of a problem and it is undestood that
; al matches
; have to get the next guy to see if he is involved here
    call  get_byte
    jnc   tr1
; no bytes left, get rid of current guy and scram
    mov   ax,di
    push  dx
    mov   dx,0
    mov   cx,5
    div   cx
    pop   dx
    call  put_byte
    ret
tr1:
; al has a character, di is the current location, we need to
; trace through to see if this is a string
;
;  test next1
;
    cmp   es:[di].first,0ffffh
    jne   tr3
; must add the first guy to di
    mov   si,di
    call  get_free  ; get the next free node into bx
    mov  es:[si].first,bx
    cmp  bx,0ffffh
    jne  tr2
    jmp  store_bytes
tr2:
    mov  es:[bx].who,al
    mov  es:[bx].next,0ffffh
    mov  es:[bx].first,0ffffh
    mov  di,si
    jmp  store_bytes
tr3:
; have a first, go to it
    mov   bx,es:[di].first
    jmp   test_f
    cmp   al,es:[bx].who
    jne   tr4
    mov   di,bx
    jmp   trace
tr4:
    mov   bx,es:[bx].next
    cmp   bx,0ffffh
    jne   test_f
no_follow:
; we have a guy in di but there is no match above
; have to add a next
    call  get_free  ; get the next free node into bx
    mov  es:[di].next,bx
    jmp  nf1
test_f:
; there is a next, follow it
    cmp   es:[bx].who,al
    je    got_hit
    cmp   es:[bx].next,0ffffh
    je    no_follow1
    mov   bx,es:[bx].next
    jmp   test_f
; got a hit
got_hit:
    inc   dx
    mov   di,bx
 ;  cmp   dx,12
 ;  jg    store_bytes
    jmp   trace
no_follow1:
; have a hit on this bx
    mov   si,bx
    call  get_free  ; get the next free node into bx
    mov  es:[si].next,bx
;
; when we get here we have a mismatch in al and as far as we got in di
; if bx = 0ffffh then we are out of string space
nf1:
    cmp  bx,0ffffh
    je   store_bytes
    mov  es:[bx].first,0ffffh
    mov  es:[bx].who,al
    mov  es:[bx].next,0ffffh
store_bytes:
    push  ax
    push  cx
    push  dx
    mov   ax,di
    mov   dx,0
    mov   cx,5
    div   cx
    pop   dx
    call  put_byte
    jc    nok_t
    cmp   free,0ffffh
    jne   no_re_init
    mov   ax,0e07h
;   int   10h
    call  init_nodes
no_re_init:
    pop   cx
    pop   ax
    mov   di,ax
    shl   di,1    ; x 2
    shl   di,1    ; x 4
    add   di,ax   ; x 5
    mov   dx,0
    call  get_byte
    jnc   trx
    ret
trx:
    push  di
    mov   si,di
    call  get_free  ; get the next free node into bx
    mov  es:[si].first,bx
    cmp  bx,0ffffh
    jne  try
    pop  di
    jmp  tr1
try:
    mov  es:[bx].who,al
    mov  es:[bx].next,0ffffh
    mov  es:[bx].first,0ffffh
    pop  di
    jmp  tr1
nok_t:
    pop   cx
    pop   ax
    stc
    ret
;
;
;
;
get_free:
; this grabs the next free guy from list
gf0:
   mov  bx,free
   cmp  bx,0ffffh
   jne  gf1
   ret
gf1:
   push dx
   mov  dx,es:[bx].next
   mov  free,dx
   pop  dx
   ret
;
;
;
;
init_nodes:
    push  ax
    push  di
    mov   di,0
    mov   bp,es
    mov   es,nodespace
    mov   cx,256
    mov   ax,0
in1:
    mov   es:[di].next,0ffffh
    mov   es:[di].first,0ffffh
    mov   es:[di].who,al
    inc   al
    add   di,5
    loop  in1
; set up the free chain
;   mov   cx,(0ffffh/5)-258
;   mov   cx,4096-256
    mov   cx,256
;   mov   cx,1024-257
in2:
    mov   ax,di
    add   ax,5
    mov   es:[di].first,0ffffh
    mov   es:[di].next,ax
    mov   di,ax
    loop  in2
    mov   es:[di].next,0ffffh
    mov   es:[di].first,0ffffh
    mov   es,bp
    mov   free,5*256
    mov   bits,9
    mov   bitsize,1ffh
    pop   di
    mov   ax,4095
;   call  put_byte
    pop   ax
    ret
;
put_byte:
 int 3
     push   ax
     push   bx
     push   di
     cmp    ax,100h
     jae    pb_2
     mov    cx,4
     add   buck2,1
     adc   buck2+2,0
     jmp   pb_3
pb_2:
     add   buck3,1
     adc   buck3+2,0
pb_3:
     clc
     mov   di,outloc
     mov   bp,es
     mov   es,buffero
     cmp   ax,4095
     je    pb_5
     cmp   ax,256
     jb    pb_4
     sub   ax,256
pb_5:
     stosw
pb_4:
     mov  es,bp
     mov  outloc,di
     cmp  di,0fff0h
     ja   fill_buff
     pop  di
     pop  bx
     pop  ax
     clc
     ret
fill_buff:
     mov   cx,di
     call  write_file
     mov   outloc,0
     pop  di
     pop  bx
     pop  ax
     clc
     ret
;
; this gets the next byte out of the buffer
get_byte:
     push  bx
     push  cx
     push  si
     push  di
     mov   si,bufferloc
     cmp   si,file_size
     jb    got_byte
     call  read_file
     mov   si,bufferloc
     cmp   ax,0
     jne   got_byte
     pop   di
     pop   si
     pop   cx
     pop   bx
     stc
     ret
got_byte:
     mov   bp,ds
     mov   ds,bufferi
     lodsb
     mov   ah,0
     mov  ds,bp
     mov   bufferloc,si
     pop   di
     pop   si
     pop   cx
     pop   bx
     clc
     ret
