cSEG        SEGMENT PARA PUBLIC 'CODE'
        ASSUME CS:CSEG,DS:CSEG,SS:CSEG,ES:CSEG ;ALREADY SET BY DOS LOADER
        ORG        100H                        ;SKIP TO END OF THE PSP
ENTPT:        JMP        setres                       ;COM FILE ENTRY ALWAYS AT 100H
; data areas
int9      dd  0
int9ip   equ word ptr int9
int9cs   equ word ptr int9 + 2
int10     dd  0
int10ip   equ word ptr int10
int10cs   equ word ptr int10 + 2
semaphore db  0
talk_switch db 0
wait1     dw  30h
START        PROC        NEAR
keyboard:
; we are entering here due to a key being struck
; first check the keyboard area to see if the CTRL and ALT are pressed
;
        push ax
        push es
        cmp  cs:semaphore,0
        jne  gotoint9
        mov  ax,40h
        mov  es,ax
        mov  al,byte ptr es:[17h]
        and  al,10
        cmp  al,10
        je   gotshift
gotoint9:
        pop  es
        pop  ax
        cli
        jmp  cs:int9
gotshift:
        pushf
        cli
        call cs:int9
        sti
gotac:
   ; check to see if the next key to come in is t  scan 14
        mov  ah,1
        int  16h
        cmp  ah,2fh
        je   goforit
        pop  es
        pop  ax
        iret
goforit:
; save the world
        sti
        push bx
        push cx
        push dx
        push si
        push di
        push ds
; get the p so others won't be messed up
        mov  ah,0
        int  16h
        mov  ax,cs
        mov  ds,ax
        mov  es,ax
        mov   semaphore,1
        cld
        xor  talk_switch,1
exit_prog:
        pop  ds
        pop  di
        pop  si
        pop  dx
        pop  cx
        pop  bx
        pop  es
        pop  ax
        mov   cs:semaphore,0
        iret
START        ENDP
video proc near
; this is used to make talker to the interrupt 10 stuff
      cmp  ah,14
      je   do_14
       jmp  cs:[int10]
do_14:
      pushf
      call  cs:[int10]
      push  ds
      push  es
      call  talk
      pop   es
      pop   ds
      iret
video endp
A db "𰟁𼀟"
  db "𼿁༟𼟇𾏃𾏃༏"
  db ""
  db " "
b db ""
  db ""
  db "ဏ "
c db ""
  db ""
  db ""
  db " "
d db "򀀰"
  db "〟ր"
  db " "
e db ""
  db ""
  db " "
f db "𘸡ǃχÇÇÇƛÎ"
  db "熟ӧ͔ÆŌ "
g db "¬Ȅ🁀"
  db ""
  db " "
h db "𼏇އ𸟰"
  db "߀"
  db "Ȉ"
  db "Հ "
i db "ǀↄČ󣜳ƈ㌬Ø"
  db "́性Ɔ́ƘÖ̢〡ʜƂ"
  db "𞇁𸇈𸇀"
  db " "
j db "ĠԐ࿇"
  db "м"
  db ""
  db "耀 "
k db "༟ǁ"
  db "𞟏𼾞฾"
  db "𼏁྇"
  db " "
l db "ÀÃÀဆ㏀Ä⌘ǌ"
  db "Â༜Ć𸰏𼘇𼎇"
  db "𼎇𼏇𼏇ฎ𜜏༇ȏÁ"
  db " "
m db "ÇĎÄЄ΀؆"
  db "ؘ"
  db "༏ฏ"
  db " "
n db "΁"
  db  "𿀏"
  db  " "
o db "𸠀Á𸜈"
  db "𸸘𜌇𰌄ఐ𼌇స"
  db "𜇃ฎ༃"
  db " "
p db ""
  db "؁"
  db " "
q db ""
  db ""
  db "Ȱ܀ "
r db "ƈ㆏玟㆏Ǐ㞎ÃΌポ东೙Ƈ"
  db "Ƈǃ̰Ɔヂ"
  db "𸜌𜎏𼞞𼞇"
  db " "
s db "윜ǏƟǎƎǎ҃"
  db "ʯ𸼟𜜟Ԁ"
  db "ހ܀"
  db " "
t db "̠ʀȀ𿀿"
  db "྘྆"
  db "༃༁ฏ "
u db ""
  db ""
  db "ྀ "
v db "耀倀ȀҀ"
  db ""
  db " "
w db "Ѐ𸜟ȸ·"
  db ""
  db "࿀ཱྀ"
  db " "
x db "ļᇎÎÏ"
  db ""
  db "ต"
  db " "
y db "🀟༇𼞎㎎Ƙ"
  db "㎰ƌ玮̸ƞ熳玌Ĺ̘矘񇞰羐猷ΘϸƘ"
  db "φ؜𞏃𼟇"
  db " "
z db "Ѐ退Ѐ"
  db ""
  db " "
n0 db "􀂀ހ࿁"
   db "߀ᾁك"
   db "𸜎ǁ珣𸌜ฌ𸎎"
   db "ุ "
n1 db "༏ྃ猸玗"
   db "㇋Ύƺ猤ܸǦļʼ˄ހ怆"
   db "Ѐ"
   db " "
n2 db "𵀁򀀔"
   db "ȟฏ༇"
   db "ఀ "
n3 db "Р􁪋"
   db "˃టɤ߅ϥ֋"
   db "࿋🁼"
   db " "
n4 db "∀񈆀"
   db "螁༾༞฾𸼌"
   db  "ǃο㲟"
   db  "𠆞 "
n5 db "ÃǜƘҙƎƎ猼ǎ昰ㆌ֜"
   db  "Ϝι̻ǞǇƞй"
  db  "ȀĂ耗"
   db  "ρ "
n6 db "Ȁ℀"
   db "𼟇蜇ꀀ"
   db "ᄅ"
   db "ђ֨Į۩酅 "
n7 db "ȠҤɉ£̘Ă"
   db "χǅǇ"
   db "𼜞𜼞"
   db " "
n8 db "ǃ𾜏"
   db "ƇƇЁ"
   db "ю蘐ᐰ΀Ș΄"
   db "Џ "
n9 db "䏴îϞތÞ"
   db "ߔÞϞ҄ÆϔƟ"
   db "܃Ƈဏ"
   db " "
HELLO db "ãᆏǟǞ𼇁"
  db "ππ༞χ"
  db "揇𸿘㇃𼜏ؼ𼏃"
  db  "༞ "
letters dw a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z
numbers dw n0,n1,n2,n3,n4,n5,n6,n7,n8,n9
TALK  proc near
; this procedure says a letter. The letter comes in in AL
; the first section converts it to an offset which is in SI
; and then calls the talker
     push cs
     pop  ds
     cmp talk_switch,0
     je  ok_voice
     ret
ok_voice:
     push  ax
     push  bx
     push  cx
     push  dx
     push  si
; convert the letter into a number
     cmp  al,30h
     jl   not_letter
     cmp  al,39h
     jg   not_number
     sub  al,30h
     mov  bl,al
     mov  bh,0
     shl  bx,1
     mov  si,numbers[bx]
     jmp  talker
not_letter:
; not a letter, pause a little
     mov   cx,4000
wait_loop1:
     add   ax,12
     sub   ax,12
     add   ax,12
     sub   ax,12
     loop  wait_loop1
     jmp   exit_talk
not_number:
     cmp  al,'A'
     jl  not_letter
     cmp  al,'z'
     jg  not_letter
     cmp al,'Z'
     jle  ok_upper
     sub  al,32
     cmp  al,'A'
     jl   not_letter
ok_upper:
     sub  al,'A'
     mov  bl,al
     mov  bh,0
     shl  bx,1
     mov  si,letters[bx]
; now do the talking
TALKER:
; on entry si points to the letter
          IN    AL,61h
          AND   AL,0F7h
          OUT   61h,AL
talk_loop0:     MOV   BH,[SI]
          CMP   BH,20h
          JZ    exit_talk
          MOV   DH,07
          SHL   BH,1
talk_loop1:     XOR   AH,AH
          SHL   BH,1
          RCL   AH,1
          RCL   AH,1
          IN    AL,61h
          AND   AL,0FCh
          ADD   AL,AH
          OUT   61h,AL
          MOV   cx,wait1
talk_wait:
          loop  talk_wait
          DEC   DH
          JNZ   talk_loop1
          INC   SI
          jmp   talk_loop0
exit_talk:
; set up wait for the character
     mov   cx,4000
wait_loop:
     add   ax,12
     sub   ax,12
     loop  wait_loop
     pop   si
     pop   dx
     pop   cx
     pop   bx
     pop   ax
          RET
talk  endp
setres  proc  near
startres:
        mov   ax,3509h
        int   21h
        mov   int9cs,es
        mov   int9ip,bx
        mov   ah,25h
        mov   al,9h
        lea   dx,keyboard
        int   21h
        mov   ax,3510h
        int   21h
        mov   int10cs,es
        mov   int10ip,bx
        mov   ah,25h
        mov   al,10h
        lea   dx,video
        int   21h
        lea   dx,mess1
        mov   ah,9
        int   21h
        lea   dx,startres
        int 27h
setres  endp
mess1   db  'Press Alt-Left Shift-V to toggle Video Voice',13,10,'$'
CSEG        ENDS
        END        ENTPT
