PROGRAM: 

STRIPT.COM Ascii Text Stripper 

CONTACT: 

Keith P. Graham, PC Rockland (914) 353-2157 

DESCRIPTION: 

STRIPT.COM is a an ascii text stripper which reformats ascii text files so that they are easier to import into VENTURA Publisher. The need for STRIPT came about because I was importing files from many different word processors into a Ventura chapter. I converted the files to ascii using the individual word processors (I printed them to a disk file in most cases). I then appended them to make one large ascii file using the DOS copy command. 

The word processors placed tabs or extra spaces throughout the text to format the page. It also placed extra lines at the top and bottom of earch page and some added chr$(12) = the page eject character. All of this stuff is pain in the but to fix. Its easier for me to write a quick and dirty page reformatter and use that so I can flow the fixed up text into Ventura. 

The strategy is to remove all sequences of more than a single space and replace them with a single space. All new line sequences are removed except for the multiple sequences which are replaced with a single new line sequence. 

Since I have removed all extra new lines I place a new line at the first space encountered after 56 characters. This gives a fairly narrow column that should be easily manipulated by an editor. 

The resulting file has all the padding on the left and right removed, and all extra internal spacing fixed. It makes every line between two double spaces into a large paragraph which is what Ventura likes to see. 

OPERATION: 

Remember, STRIPT works only on ascii files (print files). Your word processor file is NOT an ascii file. You must create the ascii file by using a conversion utility or by printing to disk. 

Edit the ascii file before running STRIPT. Use a TEXT EDITOR to change the file. Delete any extra lines or control characters that you find and make user every paragraph has a blank line between it and the next paragraph. Each line of a TABLE has to have a blank line between it and the next line. 

Run STRIPT by entering: 

STRIPT infile outfile 

Infile is the name of the input file. This is the ascii file that you want stripped. Outfile is the name of the output file. This is the file that you want to create. Infile and Outfile cannot have the same name. 

After STRIPT runs, edit the output file and make sure that it looks pretty much the way you want it to before you bring it into Ventura. Ventura is not the program that you want to use to edit the new file. 

SHAREWARE: 

STRIPT is released for free distribution without a fee. STRIPT may not be distributed for a fee except for nominal copying fees used by shareware distribution organizations.